using System;
using System.Web;
using System.Web.UI.WebControls;

/// <summary>
/// Summary description for TestState.
/// </summary>
public class TestState : System.Web.UI.Page
{
	protected System.Web.UI.WebControls.Button cmdClear;
	protected System.Web.UI.WebControls.Button cmdStore;
	protected System.Web.UI.WebControls.Label lblData;
	protected System.Web.UI.WebControls.Button cmdGetData;
		
	#region Web Form Designer generated code
	override protected void OnInit(EventArgs e)
	{
		//
		// CODEGEN: This call is required by the ASP.NET Web Form Designer.
		//
		InitializeComponent();
		base.OnInit(e);
	}
	
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{    
		this.cmdClear.Click += new System.EventHandler(this.cmdClear_Click);
		this.cmdGetData.Click += new System.EventHandler(this.cmdGetData_Click);
		this.cmdStore.Click += new System.EventHandler(this.cmdStore_Click);
		

	}
	#endregion

	private void cmdStore_Click(object sender, System.EventArgs e) {
	
		// Ein Testobjekt erstellen.
		DateTime now = DateTime.Now;

		// Objekt im Anzeigestatus speichern.
		ViewState["TestData"] = now;

		// Objekt im Sitzungsstatus speichern.
		Session["TestData"] = now;

		// Objekt in Cookie speichern.
		// berprfen, ob der Cookie bereits vorhanden ist (der Name lautet Rezept07-02).
		if (Request.Cookies["Rezept07-02"] == null) {
		
			// Cookie erstellen.
			HttpCookie cookie = new HttpCookie("Rezept07-02");

			// Der Cookie kann nur Zeichenfolgendaten speichern.
			// Er kann mehrere Werte mithilfe unterschiedlicher Schlssel speichern.
			cookie["TestData"] = now.ToString();
            
			// Sie knnen zustzliche Cookie-Eigenschaften modifizieren, um
			// das Verfallsdatum zu ndern.)

			// Den Cookie an die Antwort anhngen.
			// Er wird solange mit allen zuknftigen Anforderungen dieser
			// Site bermittelt, bis er abluft.
			Response.Cookies.Add(cookie);
		}
	}

	private void cmdGetData_Click(object sender, System.EventArgs e) {
	
		lblData.Text = "";

		// berprfen, ob Informationen im Anzeigestatus gespeichert sind.
		if (ViewState["TestData"] != null) {
		
			DateTime data = (DateTime)ViewState["TestData"];
			lblData.Text += "<b>Daten im Anzeigestatus:</b> " +
				data.ToString() + "<br>";
		}
		else {
		
			lblData.Text += "Keine Daten im Anzeigestatus gefunden.<br>";
		}

		// berprfen, ob Informationen im Sitzungsstatus gespeichert sind.
		if (Session["TestData"] != null) {
		
			DateTime data = (DateTime)Session["TestData"];
			lblData.Text += "<b>Daten im Sitzungsstatus:</b> " +
				data.ToString() + "<br>";
		}
		else {
		
			lblData.Text += "Keine Daten im Sitzungsstatus gefunden.<br>";
		}

		// berprfen, ob Informationen im benutzerdefinierten Cookie gespeichert sind.
		HttpCookie cookie = Request.Cookies["Rezept07-02"];
		if (cookie != null) {
		
			string cookieData = (string)cookie["TestData"];
			lblData.Text += "<b>Daten im Cookie:</b> " +
				cookieData + "<br>";
		}
		else {
		
			lblData.Text += "Keine Daten im Cookie gefunden.<br>";
		}
	}

	private void cmdClear_Click(object sender, System.EventArgs e) {
	
		ViewState["TestData"] = null;
        Session["TestData"] = null;
		// (Sie knnen ebenfalls Session.Abandon benutzen, um alle Sitzungsinformationen zu lschen.)

		// Um einen Cookie zu lschen, mssen Sie ihn durch einen Cookie mit einem Verfallsdatum
		// ersetzen, das bereits abgelaufen ist.
		HttpCookie cookie = new HttpCookie("Rezept07-02");
		cookie.Expires = DateTime.Now.AddDays(-1);
		Response.Cookies.Add(cookie);
	}
}