using System;
using System.Web;
using System.Web.UI.WebControls;

/// <summary>
/// Summary description for StatefulMembers.
/// </summary>
public class StatefulMembers : System.Web.UI.Page
{
	protected System.Web.UI.WebControls.TextBox txtValue;
	protected System.Web.UI.WebControls.Button cmdSet;
	protected System.Web.UI.WebControls.Label lblCurrent;

	private int memberValue = 0;

	private void Page_Load(object sender, System.EventArgs e) {
	
		if (ViewState["memberValue"] != null) {

			// Alle Membervariablen neu laden.	
			memberValue = (int)ViewState["memberValue"];
		}
	}

	#region Web Form Designer generated code
	override protected void OnInit(EventArgs e)
	{
		//
		// CODEGEN: This call is required by the ASP.NET Web Form Designer.
		//
		InitializeComponent();
		base.OnInit(e);
	}
	
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{    
		this.cmdSet.Click += new System.EventHandler(this.cmdSet_Click);
		this.Load += new System.EventHandler(this.Page_Load);
		this.PreRender += new System.EventHandler(this.StatefulMembers_PreRender);

	}
	#endregion

	private void StatefulMembers_PreRender(object sender, System.EventArgs e) {
	
		// Alle Membervariablen speichern.
		ViewState["memberValue"] = memberValue;

		// Wert anzeigen.
		lblCurrent.Text = memberValue.ToString();
	}

	private void cmdSet_Click(object sender, System.EventArgs e)
	{
		memberValue = Int32.Parse(txtValue.Text);
	}
}