using System;
using System.Web;
using System.Web.UI.WebControls;
using System.Drawing;
using System.Drawing.Drawing2D;

/// <summary>
/// Summary description for DynamicGraphic.
/// </summary>
public class DynamicGraphic : System.Web.UI.Page
{
	private void Page_Load(object sender, System.EventArgs e)
	{
		// Den Text aus der Abfragezeichenfolge abrufen.
		// Wenn kein Text zur Verfgung gestellt wird, den Vorgabewert verwenden.
		string text = "";
		if (Request.QueryString["image"] == null)
		{
			Response.Redirect(Request.Url + "?image=" +
                Server.UrlEncode("Dies ist ein Testbild"));
		}
		else
		{
			text = Server.UrlDecode(Request.QueryString["image"]);
		}
		
		// Eine speicherinterne Bitmap erstellen, in die Sie das Bild zeichnen. 
        // Die Bitmap ist 300 Pixel breit und 200 Pixel hoch.
		int width = 300, height = 200;
		Bitmap bitmap = new Bitmap(width, height);

		// Den Grafikkontext der Bitmap abrufen.
		Graphics graphics = Graphics.FromImage(bitmap);

		// Die Hintergrundfarbe und Ausgabequalitt setzen.
		// Diese Farbe bildet den Rahmen.
		graphics.Clear(Color.OrangeRed);
		graphics.SmoothingMode = SmoothingMode.AntiAlias;

		// Ein Rechteck zeichnen.
		graphics.FillRectangle(new SolidBrush(Color.Olive), 5, 5, 
			width - 10, height - 10);

		// Eine Schrift und Ausrichtung fr den Text auswhlen.
		Font fontBanner = new Font("Verdana", 24, FontStyle.Bold);
		StringFormat stringFormat = new StringFormat();
		stringFormat.Alignment = StringAlignment.Center;
		stringFormat.LineAlignment = StringAlignment.Center;

		// Den Text ausgeben.
		graphics.DrawString(text, fontBanner, new 
			SolidBrush(Color.LightYellow), new Rectangle(0, 0, width, height), 
			stringFormat);

		// Das Bild in einer Datei speichern.
		//bitmap.Save(strFilename, ImageFormat.Jpeg);

		// Das Bild in den HTML-Ausgabe-Stream ausgeben.
		bitmap.Save(Response.OutputStream, 
		    System.Drawing.Imaging.ImageFormat.Gif);

		graphics.Dispose();
		bitmap.Dispose();
	}

	#region Web Form Designer generated code
	override protected void OnInit(EventArgs e)
	{
		//
		// CODEGEN: This call is required by the ASP.NET Web Form Designer.
		//
		InitializeComponent();
		base.OnInit(e);
	}
	
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{    
		this.Load += new System.EventHandler(this.Page_Load);
	}
	#endregion
}