using System;
using System.Data;
using System.Web;
using System.Configuration;
using System.Diagnostics;
using System.Web.Caching;
using System.Data.SqlClient;


/// <summary>
/// Summary description for DataCache.
/// </summary>
public class DataCache : System.Web.UI.Page
{

	#region Web Form Designer generated code
	override protected void OnInit(EventArgs e)
	{
		//
		// CODEGEN: This call is required by the ASP.NET Web Form Designer.
		//
		InitializeComponent();
		base.OnInit(e);
	}
	
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{    
		this.cmdGetData.Click += new System.EventHandler(this.cmdGetData_Click);

	}
	#endregion

	protected System.Web.UI.WebControls.DataGrid DataGrid1;
	protected System.Web.UI.WebControls.Label lblInfo;
	protected System.Web.UI.WebControls.Button cmdGetData;


	private void cmdGetData_Click(object sender, System.EventArgs e)
	{
		CustomerDatabase custDB = new CustomerDatabase();
		DataGrid1.DataSource = custDB.GetCustomers();
		DataGrid1.DataBind();		
	}

}

public class CustomerDatabase
{
	private string connectionString;

	// Verweis auf das Cache-Objekt abrufen.
	private Cache cache = HttpContext.Current.Cache;

	public CustomerDatabase()
	{
		// Die Verbindungszeichenfolge aus der Datei web.config abrufen.
		connectionString = ConfigurationSettings.AppSettings["NorthwindCon"];
	}

	public DataSet GetCustomers()
	{
		DataSet customersDS;

		// berprfen, ob zwischengespeicherte Elemente vorhanden sind.
		if (cache["Customers"] == null)
		{
			// DataSet aus der Datenbank abrufen.
			customersDS = GetCustomersFromDatabase();
            
			// Das Element mit einer gleitenden Verfallrichtlinie
			// von 60 Sekunden im Cache speichern.
			cache.Insert("Customers", customersDS, null,
				DateTime.MaxValue, TimeSpan.FromSeconds(60));

			// Eine Debug-Meldung anzeigen.
			Debug.WriteLine("DataSet wurde aus Datenquelle erzeugt.");
		}
		else
		{
			// Eine Debug-Meldung anzeigen.
			Debug.WriteLine("DataSet wurde aus Cache abgerufen.");
            
			// Element abrufen.
			customersDS = (DataSet)cache["Customers"];
		}
			
		// DataSet zurckgeben.
		return customersDS;
	}

	private DataSet GetCustomersFromDatabase()
	{
		// DataSet erstellen.
		DataSet customersDS = new DataSet();
            
		// DataSet fllen (mit den Daten einer Datei).
		SqlConnection con = new SqlConnection(connectionString);
		SqlCommand cmd = new SqlCommand("SELECT * FROM Customers", con);

		SqlDataAdapter adapter = new SqlDataAdapter(cmd);
		try
		{
			con.Open();
			adapter.Fill(customersDS, "Customers");
		}
		catch
		{
			customersDS = null;
		}
		finally
		{
			con.Close();
		}

		return customersDS;
	}

}