using System;
using System.Threading;

namespace Client
{
	public class WaitClient
	{
		[MTAThread]
		private static void Main()
		{
			localhost.WaitService proxy = new localhost.WaitService();

			// Die verstrichene Zeit erfassen.
			DateTime startDate = DateTime.Now;

			// Drei Methoden asynchron aufrufen.
			IAsyncResult handle1 = proxy.BeginWait(null, null);
			IAsyncResult handle2 = proxy.BeginWait(null, null);
			IAsyncResult handle3 = proxy.BeginWait(null, null);

			WaitHandle[] waitHandle = {handle1.AsyncWaitHandle,
										  handle2.AsyncWaitHandle, handle3.AsyncWaitHandle};

			// Auf das Ende aller Aufrufe warten.
			WaitHandle.WaitAll(waitHandle);

			int totalDelay = proxy.EndWait(handle1) + proxy.EndWait(handle2) +
				proxy.EndWait(handle3);
			TimeSpan elapsedTime = DateTime.Now - startDate;

			Console.WriteLine("Beendet nach " + elapsedTime.ToString());
			Console.WriteLine("Gesamtverzgerungszeit: " + totalDelay.ToString());

			Console.ReadLine();
		}

	// Alternative Main-Funktion, die die BeginWait-Methode mit einem Rckruf aufruft.
	/*	[MTAThread]
		private static void Main()
		{
			localhost.WaitService proxy = new localhost.WaitService();

			AsyncCallback callback = new AsyncCallback(Callback);

			// Methode asynchron und mit Rckruf starten. 
			proxy.BeginWait(callback, proxy);

			Console.ReadLine();
		}
	*/
		public static void Callback(IAsyncResult handle) 
		{

			localhost.WaitService proxy = (localhost.WaitService)handle.AsyncState;
			int result = proxy.EndWait(handle);
			Console.WriteLine("Gewartet " + result.ToString());
		}
	}
}