using System;
using System.Runtime.Remoting;
using System.Reflection;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;

namespace Server
{
	public class Server
	{
		private static void Main()
		{
			// Die Konfigurationsdatei verwenden, um Netzwerkoptionen zu definieren.
			RemotingConfiguration.Configure("Server.exe.config");

			// Den registrierten Remoting-Kanal abrufen. 
			TcpChannel channel = (TcpChannel)ChannelServices.RegisteredChannels[0];

            // Ein Assembly-Objekt erstellen, das die Assembly reprsentiert,
			// in der die remote-fhigen Klassen definiert sind.
			Assembly assembly = Assembly.LoadFrom("RemoteObject.dll");

			// Alle Typen in dieser Assembly verarbeiten.
			foreach (Type type in assembly.GetTypes())
			{
				// Prfen, ob es sich um einen remote-fhigen Typ handelt.
				if (type.IsSubclassOf(typeof(MarshalByRefObject)))
				{
					// Jeden Typ mit dem Typnamen als URI registrieren
					// (wie ProductsDB).
					Console.WriteLine("Registriere " + type.Name);
					RemotingConfiguration.RegisterWellKnownServiceType( 
						type, type.Name, WellKnownObjectMode.SingleCall);

					// Den URL ermitteln, wo dieser Typ verffentlicht wird.
					string[] urls = channel.GetUrlsForUri(type.Name);
					Console.WriteLine(urls[0]);
				}
			}			

			Console.WriteLine("Drcken Sie eine Taste, um den Server herunterzufahren.");
			Console.ReadLine();
		}
	}
}
