using System;
using System.IO;
using System.Text;

public class CharacterEncodingExample {

    public static void Main() {
        
        // Eine Datei fr die Ausgaben erstellen
        using (StreamWriter output = new StreamWriter("output.txt")) {

            // Zeichenkette mit einem Pi-Symbol erstellen
            // und in die Datei ausgeben
            string srcString = "Area = \u03A0r^2";
            output.WriteLine("Quelltext : " + srcString);

            // UTF-16-kodierte Bytes der Eingabezeichenfolge ausgeben
            byte[] utf16String = Encoding.Unicode.GetBytes(srcString);
            output.WriteLine("UTF-16 Bytes: {0}", 
                BitConverter.ToString(utf16String));

            // UTF-16-kodierte Bytes der Eingabezeichenfolge 
            // in UTF-8 und ASCII umkodieren
            byte[] utf8String = Encoding.UTF8.GetBytes(srcString);
            byte[] asciiString = Encoding.ASCII.GetBytes(srcString);
   
            // UTF-8- und ASCII-codierte Byte-Arrays ausgeben       
            output.WriteLine("UTF-8  Bytes: {0}", 
                BitConverter.ToString(utf8String));
            output.WriteLine("ASCII  Bytes: {0}", 
                BitConverter.ToString(asciiString));

            // UTF-8- und ASCII-codierte Bytes zurck in UTF-16-kodierte
            // Zeichenfolge konvertieren und ausgeben
            output.WriteLine("UTF-8  Text : {0}", 
                Encoding.UTF8.GetString(utf8String));
            output.WriteLine("ASCII  Text : {0}", 
                Encoding.ASCII.GetString(asciiString));

            // Ausgabedatei auf Datentrger schreiben und schlieen
            output.Flush();
            output.Close();
        }
    }
}
