using System.Reflection;
using System.Text.RegularExpressions;

public class CompiledRegexExample {

    public static void Main() {

        // Erstellen eines Arrays, der die Regex-Info-Objekte enthalten wird
        RegexCompilationInfo[] regexInfo = new RegexCompilationInfo[2];

        // Erstellen von RegexCompilationInfo fr PinRegex
        regexInfo[0] = new RegexCompilationInfo(@"^\d{4}$", 
            RegexOptions.Compiled, "PinRegex", "", true);

        // Erstellen von RegexCompilationInfo fr CreditCardRegex
        regexInfo[1] = new RegexCompilationInfo( 
            @"^\d{4}-?\d{4}-?\d{4}-?\d{4}$", 
            RegexOptions.Compiled, "CreditCardRegex", "", true);

        // Erstellen von AssemblyName, um die Zielassambly zu definieren
        AssemblyName assembly = new AssemblyName();
        assembly.Name = "MyRegEx";

        // Erstelllen des kompilierten regulren Ausdrucks
        Regex.CompileToAssembly(regexInfo, assembly);
    }
}
