using System;

public class DateTimeCreationExample
{
	public static void Main(string[] args) {

        // 01/09/2001 00:00:00
        DateTime dt1 = DateTime.Parse("Sep 2001");
        // 05/09/2001 14:15:33
        DateTime dt2 = DateTime.Parse("Wed 5 September 2001 14:15:33");
        // 05/09/2001 00:00:00
        DateTime dt3 = DateTime.Parse("5,9,01");
        // 05/09/2001 14:15:33
        DateTime dt4 = DateTime.Parse("5/9/2001 14:15:33");
        // 01/07/2003 14:15:00
        DateTime dt5 = DateTime.Parse("2:15 PM");

        Console.WriteLine(dt1);
        Console.WriteLine(dt2);
        Console.WriteLine(dt3);
        Console.WriteLine(dt4);
        Console.WriteLine(dt5);

        // Nur Zeichenketten veratrbeiten, die dem Muster 
        // LongTimePattern entsprechen
        DateTime dt6 = DateTime.ParseExact("2:13:30 PM",
            "h:mm:ss tt", null);

        // Nur Zeichenketten veratrbeiten, die dem Muster 
        // RFC1123Pattern entsprechen
        DateTime dt7 = DateTime.ParseExact(
            "Wed, 05 Sep 2001 14:13:30 GMT",
            "ddd, dd MMM yyyy HH':'mm':'ss 'GMT'", null);

        // Nur Zeichenketten veratrbeiten, die dem Muster 
        // MonthDayPattern entsprechen
        DateTime dt8 = DateTime.ParseExact("September 03",
            "MMMM dd", null);

		Console.WriteLine(dt6);
		Console.WriteLine(dt7);
		Console.WriteLine(dt8);

		// Auf Tastendruck warten...
		Console.ReadLine();
    }
}
