using System;
using System.Reflection;
using System.Globalization;

public class LadeAssemblyBeispiel
{
	public static void Main() {

        // Alle Assemblys in der aktuellen Anwendungsdomne auflisten
        Console.WriteLine("**** VORHER ****");
        ListAssemblies();

		// Laden der System.Data-Assembly unter Verwendung
		// des vollstndig angegebenen Anzeigenamens.
		string name1 = "System.Data,Version=1.0.5000.0," + 
                        "Culture=neutral,PublicKeyToken=b77a5c561934e089";
        Assembly a1 = Assembly.Load(name1);

		// Laden der Assembly System.Xml mittels eines AssemblyName-Objekts.
		AssemblyName name2 = new AssemblyName();
        name2.Name = "System.Xml";
        name2.Version = new Version(1,0,5000,0);
        name2.CultureInfo = new CultureInfo("");
        name2.SetPublicKeyToken(
            new byte[] {0xb7,0x7a,0x5c,0x56,0x19,0x34,0xe0,0x89});
        Assembly a2 = Assembly.Load(name2);

		// Laden der Assembly "EineAssembly" mittels eines teilweisen
		// Assemblynamens
        Assembly a3 = Assembly.Load("EineAssembly");

        // Laden einer Assembly namens c:\freigegeben\MeineFreigegAssembly.dll
        Assembly a4 = Assembly.LoadFrom(@"c:\freigegeben\MeineFreigegAssembly.dll");
    
        // Alle Assemblys in der aktuellen Anwendungsdomne auflisten
        Console.WriteLine("**** NACHHER ****");
        ListAssemblies();

        // Auf Tastendruck warten
        Console.ReadLine();
    }

    public static void ListAssemblies () {
     
        // Beschaffen eines Arrays mit den Assemblys, die in der
	// aktuellen Anwendungsdomne geladen sind.
        Assembly[] assemblies = AppDomain.CurrentDomain.GetAssemblies();

        foreach (Assembly a in assemblies) {

            Console.WriteLine(a.GetName());

        }
    }
}
