using System;
using System.IO;

public class TypTestBeispiel {

    // Testen,  ob ein Objekt eine Instanz eines Typs oder eines 
    // abgeleiteten Typs ist.
    public static bool IsType(object obj, string type) {

		// Abrufen des benannten Typs. Die Gro-/Kleinschreibung wird whrend der
		// Suche bercksichtigt. Auslsen einer Ausnahme, wenn der Typ nicht auffindbar ist.
        Type t = Type.GetType(type, true, true);

        return t == obj.GetType() || obj.GetType().IsSubclassOf(t);
    }

    public static void Main() {

        // Erstellen eines StringReader-Objekts zu Testzwecken.
        Object einObjekt = 
            new StringReader("Dies ist ein StringReader");

        // berprfen, ob einObjekt vom Typ StringReader ist, indem eine 
        // Typreferenz abgerufen und mithilfe des typeof-Operators verglichen wird.
        if (typeof(System.IO.StringReader) == einObjekt.GetType()) {

            Console.WriteLine("typeof: einObjekt ist ein StringReader");
        }

        // Mithilfe des is-Operators berprfen, ob einObjekt ein TextReader 
	    // oder ein davon abgeleiteter Typ ist.
        if (einObjekt is System.IO.TextReader) {

            Console.WriteLine("is: einObjekt ist ein TextReader oder eine abgeleitete Klasse");
        }


        // Mithilfe der Methoden Type.GetType und Type.IsSubclassOf berprfen, 
	    // ob einObjekt ein TextReader oder ein davon abgeleiteter Typ ist.
        if (IsType(einObjekt, "System.IO.TextReader")) {

            Console.WriteLine("GetType: einObjekt ist ein TextReader");
        }

        // Verwenden des as-Operators, um eine sichere Konvertierung durchzufhren.
        StringReader reader = einObjekt as System.IO.StringReader;
        if (reader != null) {

            Console.WriteLine("as: einObjekt ist ein StringReader");
        }

		// Auf Tastendruck warten
		Console.ReadLine();
    }
}
