using System;
using System.Text;
using System.Reflection;
using System.Collections;

public class ObjektErstellBeispiel {

    public static StringBuilder ErstelleStringBuilder() {

        // Abrufen des Types fr die StringBuilder-Klasse.
        Type type = typeof(System.Text.StringBuilder);

		// Erstellen von Type[], das die Type-Instanzen fr jeden
		// Konstruktorparameter enthlt - ein String und ein Int.
        Type[] argTypen = new Type[] {typeof(System.String), typeof(System.Int32)};

		// Abrufen des ConstructorInfo-Objekts.
        ConstructorInfo cInfo = type.GetConstructor(argTypen);

		// Erstellen von object[]. Enthlt die Konstruktorparameter.
        object[] argVals = new object[] {"Ein String", 30};

        // Erstellen eines Objekts, das in den StringBuilder-Typ konvertiert wird.
        StringBuilder sb = (StringBuilder)cInfo.Invoke(argVals);

        return sb;
    }

	public static void Main(string[] args) {

        // Erstellen eines StringBuilder-Objekts
        StringBuilder sb = ErstelleStringBuilder();

        // Instanziieren eines neuen IPlugin mittels der PluginFactory.
        IPlugin plugin = PluginFactory.CreatePlugin(
            "ObjektErstellBeispiel",  // Privater Assemblyname
            "SimplesPlugin",         // Plug-In-Klassenname
            "ein simples Plug-In"       // Plug-In-Instanzbeschreibung
        );
 
        // Starten und stoppen des neuen Plug-Ins.
        plugin.Start();
        plugin.Stop();

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
