using System;
using System.Threading;

public class ThreadExample {

	// Private Member-Variable speichert den Zustand fr die Verwendung durch neuen Thread.
    private int iterations;
    private string message;
    private int delay;

    public ThreadExample(int iterations, string message, int delay) {

        this.iterations = iterations;
        this.message = message;
        this.delay = delay;
    }

	public void Start() {

        // Eine ThreadStart-Delegateninstanz erstellen, die DisplayMessage referenziert.
        ThreadStart method = new ThreadStart(this.DisplayMessage);

        // Erstellen eines neuen Thread-Objektes, und seinem Konstruktor
		// die ThreadStart-Delegateninstanz bergeben.
        Thread thread = new Thread(method);

        Console.WriteLine("{0} : Neuen Thread starten.",  
            DateTime.Now.ToString("HH:mm:ss.ffff"));

        // Neuen Thread starten
        thread.Start();
    }

    private void DisplayMessage() {

        // Die Nachricht sooft wie angegeben im Konsolenfenster ausgeben;
		// zwischen den Ausgaben fr die angegebene Zeit warten.
        for (int count = 0; count < iterations; count++) {

            Console.WriteLine("{0} : {1}",  
                DateTime.Now.ToString("HH:mm:ss.ffff"), message);

            // Thread fr die angegebene Zeit aussetzen.
            Thread.Sleep(delay);
        }
    }

    public static void Main() {

        // Ein neues ThreadExample-Objekt erstellen.
        ThreadExample example = 
            new ThreadExample(5, "Ein Thread-Beispiel.", 500);

        // Das Thread-Beispielobjekt starten.
        example.Start();

        // Mit der weiteren Verarbeitung fortfahren.
        for (int count = 0; count < 13; count++) {
            Console.WriteLine("{0} : Verarbeitung fortfhren...", 
                DateTime.Now.ToString("HH:mm:ss.ffff"));
            Thread.Sleep(200);
        }

        // Wait to continue.
        Console.WriteLine("Hauptmethode abgeschlossen. Drcken Sie Return.");
        Console.ReadLine();
    }
}
