using System;
using System.Threading;

public class ThreadFinishExample {

    private static void DisplayMessage() {

        // Die Nachricht im Konsolenfenster fnf mal ausgeben.
        for (int count = 0; count < 5; count++) {

            Console.WriteLine("{0} : Zweiter Thread",  
                DateTime.Now.ToString("HH:mm:ss.ffff"));

            // Thread eine Sekunde aussetzen.
            Thread.Sleep(1000);
        }
    }

    public static void Main() {

        // Erstellen eines ThreadStart-Delegateninsanz, die DisplayMessage referenziert.
        ThreadStart method = new ThreadStart(DisplayMessage);

        // Erstellen eines neuen Thread-Objektes, und die ThreadStart-Delegateninstanz
		// seinem Konstruktor bergeben.
        Thread thread = new Thread(method);

        Console.WriteLine("{0} : Starten des zweiten Threads.",  
            DateTime.Now.ToString("HH:mm:ss.ffff"));

        // Einen zweiten Thread starten
        thread.Start();

        // Thread blockieren, bis der zweite Thread beendet wird, oder der
		// Timeout nach 3 Sekunden erreicht wird.
        if (!thread.Join(3000)) {

            Console.WriteLine("{0} : Timeout erreicht !!",  
                DateTime.Now.ToString("HH:mm:ss.ffff"));
        }

        // Auf Programmende warten.
        Console.WriteLine("Hauptmethode abgeschlossen. Drcken Sie Return.");
        Console.ReadLine();
    }
}