using System.Collections;
using System.Collections.Specialized;

public class SynchronizedCollectionExample {

    public static void Main() {

        // *****************************************
        // Synchronisieren von Standardauflistungen.
        // *****************************************

        // Eine normale Hashtable erstellen
        Hashtable hUnsync = new Hashtable();

        // Einen synhronisierten Wrapper fr die Hashtable erstellen.
        Hashtable hSync = Hashtable.Synchronized(hUnsync);

        // Auf die Hashtable ber den synchronisierten Wrapper zugreifen...

        // ***************************************
        // Synchronisieren spezieller Auflistungen
        // ***************************************

        // Eine NameValueCollection-Auflistung erstellen.
        NameValueCollection nvCollection = new NameValueCollection();

        // Einen Lock auf NameValueCollection vor ihrer Modifizierung einrichten.
        lock (((ICollection)nvCollection).SyncRoot) {

            // Die NameValueCollection modifizieren.
        }
    }
}
