using System;
using System.Diagnostics;

public class StartProcessExample {

    public static void Main () {

        // Ein ProcessStartInfo-Objekt erstellen und dieses so konfigurieren,
		// dass es die zum Ablauf bentigten Informationen enthlt.
        ProcessStartInfo startInfo = new ProcessStartInfo();

        startInfo.FileName = "notepad.exe";
        startInfo.Arguments = "file.txt";
        startInfo.WorkingDirectory = @"C:\Temp";
        startInfo.WindowStyle = ProcessWindowStyle.Maximized;
        startInfo.ErrorDialog = true;

        // Ein neues Prozessobjekt erstellen.
        using (Process process = new Process()) {

            // ProcessStartInfo dem Prozess zuordnen.
            process.StartInfo = startInfo;

            try {

                // Den neuen Prozess starten.
                process.Start();

                // Warten, bis der neue Prozess beendet wurde, bevor das Programm endet.
                Console.WriteLine("Dem Prozess 30 Sekunden zum Beenden" +
                    " zeitgeben.");
                process.WaitForExit(30000);

            } catch (Exception ex) {

                Console.WriteLine("Prozess konnte nicht gestartet werden.");
                Console.WriteLine(ex);
            }
        }

        // Auf Programmende warten.
        Console.WriteLine("Hauptmethode abgeschlossen. Drcken Sie Return.");
        Console.ReadLine();
    }
}
