using System;
using System.Threading;
using System.Diagnostics;

public class TerminateProcessExample {

    public static void Main () {

        // Neuen Prozess erstellen und Notepad.exe starten.
        using (Process process = Process.Start("notepad.exe")) {

            // Fr 5 Sekunden warten, bevor der Notepad-Prozess beendet wird.
            Console.WriteLine("Fr 5 Sekunden warten, bevor" +
                " notepad.exe beendet wird.");
            Thread.Sleep(5000);

            // Notepad-Prozess beenden.
            Console.WriteLine("Notepad mit CloseMainWindow beenden.");

            // Versuchen, CloseMainWindow als Nachricht an Notepad zu verschicken.
            if (!process.CloseMainWindow()) {

                // Nachricht konnte nicht gesendet werden - Notepad-Task abschieen.
                Console.WriteLine("CloseMainWindow hat 'false' zurckgeliefert - " +
                    " Notepad-Task wird abgeschossen.");
                process.Kill();

            } else {

                // Nachricht konnte erfolgreich versendet werden; 2 Sekunden warten
				// bis zur Beendigungsbesttigung, bevor Plan B doch wieder
				// durchgefhrt wird (Abschieen des Tasks).
                if (!process.WaitForExit(2000)) {

                    Console.WriteLine("CloseMainWindow ist fehlgeschlagen" +
                        " - Notepad-Task wird abgeschossen.");
                    process.Kill();
                }
            }
        }

        // auf Programmende warten.
        Console.WriteLine("Hauptmethode beendet. Drcken Sie Return.");
        Console.ReadLine();
    }
}
