using System;
using System.Threading;

public class MutexExample {

    public static void Main() {

        // Ein Boolean der anzeigt, ob die Anwendung anfnglicher
		// Besitzer des Mutex ist.
        bool ownsMutex;

        // Versuchen, einen Mutex namens MutexExample zu erstellen und
		// dessen Besitz zu bernehmen.
        using (Mutex mutex = 
                   new Mutex(true, "MutexExample", out ownsMutex)) {

            // Falls die Anwendung den Mutex besitzt, kann sie ungestrt fortfahren;
			// anderenfalls soll die Anwendung beendet werden.
            if (ownsMutex) {

				Console.WriteLine("Diese Anwendung besitzt gegenwrtig den Mutex" +
					" namens MutexExample. Weitere Instanzen dieser Anwendung" +
					" knnen nicht gestartet werden, bevor Sie den Mutex durch" +
					" Drcken von Return freigeben.");
				
                Console.ReadLine();

                // Mutex freigeben
                mutex.ReleaseMutex();

            } else {


				Console.WriteLine("Eine andere Instanz dieser Anwendung " +
					" besitzt bereits den Mutex namens MutexExample. Diese" +
					" Instanz der Anwendung wird daher beendet.");
				
            }
        }

        // Auf Programmende warten.
        Console.WriteLine("Hauptmethode abgeschlossen. Drcken Sie Return.");
        Console.ReadLine();
    }
}