using System;
using System.Xml;

public class GenerateXml
{
	/// <summary>
	/// Der Haupteinstiegspunkt der Anwendung.
	/// </summary>
	[STAThread]
	private static void Main(string[] args)
	{
		// Neues, leeres Dokument erstellen.
		XmlDocument doc = new XmlDocument();
		XmlNode docNode = doc.CreateXmlDeclaration("1.0", "UTF-8", null);
		doc.AppendChild(docNode);

		// Neues Element erstellen und einfgen.
		XmlNode productsNode = doc.CreateElement("products");
		doc.AppendChild(productsNode);

		// Eingebettetes Element (mit einem Attribut) erstellen.
		XmlNode productNode = doc.CreateElement("product");
		XmlAttribute productAttribute = doc.CreateAttribute("id");
		productAttribute.Value = "1001";
		productNode.Attributes.Append(productAttribute);
	    productsNode.AppendChild(productNode);

        // Erstellen und hinzufgen der Unterelemente fr diesen
		// Produkt-Strukturknoten (mit den enthaltenen Text-Daten).
		XmlNode nameNode = doc.CreateElement("productName");
		nameNode.AppendChild(doc.CreateTextNode("Gourmet-Kaffee"));
		productNode.AppendChild(nameNode);
		XmlNode priceNode = doc.CreateElement("productPrice");
		priceNode.AppendChild(doc.CreateTextNode("0.99"));
		productNode.AppendChild(priceNode);

		// Einen weiteren Produktknoten erstellen und hinzufgen.
		productNode = doc.CreateElement("product");
		productAttribute = doc.CreateAttribute("id");
		productAttribute.Value = "1002";
		productNode.Attributes.Append(productAttribute);
		productsNode.AppendChild(productNode);
		nameNode = doc.CreateElement("productName");
		nameNode.AppendChild(doc.CreateTextNode("Blue China Tee-Kessel"));
		productNode.AppendChild(nameNode);
		priceNode = doc.CreateElement("productPrice");
		priceNode.AppendChild(doc.CreateTextNode("102.99"));
		productNode.AppendChild(priceNode);

        // Das Dokument speichern (ins Konsolenfenster anstatt in eine Datei).
		doc.Save(Console.Out);
		Console.ReadLine();
		
	}
}