using System;
using System.Xml;
using System.IO;
using System.Text;


public class ReadWriteXml
{
	private static void Main()
	{
		// Datei und Writer-Objekt erstellen.
		FileStream fs = new FileStream("products.xml", FileMode.Create);
		XmlTextWriter w = new XmlTextWriter(fs, Encoding.UTF8);

		// Dokument beginnen.
		w.WriteStartDocument();
		w.WriteStartElement("products");

		// Produkt schreiben.
		w.WriteStartElement("product");
		w.WriteAttributeString("id", "1001");	
		w.WriteElementString("productName", "Gourmet-Kaffee");
		w.WriteElementString("productPrice", "0.99");
		w.WriteEndElement();

		// Weiteres Produkt schreiben.
		w.WriteStartElement("product");
		w.WriteAttributeString("id", "1002");	
		w.WriteElementString("productName", "Blue China Teekessel");
		w.WriteElementString("productPrice", "102.99");
		w.WriteEndElement();

		// Dokument abschlieen.
		w.WriteEndElement();
		w.WriteEndDocument();
		w.Flush();
		fs.Close();
			
		Console.WriteLine("Document erstellen. " + 
            "Drucken Sie Return, um das Dokument zu lesen.");
		Console.ReadLine();

		fs = new FileStream("products.xml", FileMode.Open);
		XmlTextReader r = new XmlTextReader(fs);
		
		// Alle Strukturknoten lesen.
		while (r.Read())
		{
			if (r.NodeType == XmlNodeType.Element)
			{
				Console.WriteLine();
				Console.WriteLine("<" + r.Name + ">");
				if (r.HasAttributes)
				{
					for (int i = 0; i < r.AttributeCount; i++)
					{
						Console.WriteLine("\tATTRIBUT: " + r.GetAttribute(i));
                    }
				}
			}
			else if (r.NodeType == XmlNodeType.Text)
			{
				Console.WriteLine("\tWert: " + r.Value);
			}
		}
		Console.ReadLine();
	}
}
