using System;
using System.Xml;
using System.IO;

namespace Recipe05_13
{
	public class StoreBinaryData
	{
		private static void Main()
		{
			// Ein neues, leeres Dokument erstellen.
			XmlDocument doc = new XmlDocument();
			XmlNode docNode = doc.CreateXmlDeclaration("1.0", "UTF-8", null);
			doc.AppendChild(docNode);

			// Erstellen und einfgen eines neuen Elementes.
			XmlNode pictureNode = doc.CreateElement("Picture");
			doc.AppendChild(pictureNode);

			XmlNode node = doc.CreateElement("Name");
			node.AppendChild(doc.CreateTextNode("Windows logo"));
			pictureNode.AppendChild(node);

			// Die Bilddaten in einem Byte-Array ermitteln.
			FileStream fs = new FileStream("bluelace.bmp", FileMode.Open);
			byte[] bytes = new byte[Convert.ToInt32(fs.Length)];
            fs.Read(bytes, 0, bytes.Length);

		    // Bilddaten encodieren und als Text hinzufgen.
			string encodedImage = Convert.ToBase64String(bytes);
			
			// Bilddaten hinzufgen.
			node = doc.CreateElement("ImageData");
			node.AppendChild(doc.CreateTextNode(encodedImage));
			pictureNode.AppendChild(node);

            // Dokument darstellen.
			doc.Save(Console.Out);

			Console.ReadLine();
		}
	}
}
