using System;
using System.Xml;
using System.Data.SqlClient;

namespace Recipe05_14
{
	public class ForXmlQuery
	{
		private static string connectionString = "Data Source=localhost;" +
			"Initial Catalog=Northwind;Integrated Security=SSPI";

		private static string customerQuery =
			"SELECT CustomerID, CompanyName FROM Customers FOR XML AUTO";

		public static void Main() 
		{
			// Erstellen der ADO.NET-Objekte.
			SqlConnection con = new SqlConnection(connectionString);
			SqlCommand com = new SqlCommand(customerQuery, con);

			// Befehl ausfhren.
			try
			{
				con.Open();
				XmlReader reader = com.ExecuteXmlReader();
				while (reader.Read())
				{
 
					Console.Write("Element: " + reader.Name);

					if (reader.HasAttributes)
					{
						for (int i = 0; i < reader.AttributeCount; i++)
						{
							reader.MoveToAttribute(i);
							Console.Write("   ");
							Console.Write(reader.Name + ": ");
							Console.Write(reader.Value);
						}

						// Zum Element-Strukturknoten zurckgehen.
						reader.MoveToElement();
						Console.WriteLine();

					}
				}
				reader.Close();
			}
			catch (Exception err)
			{
				Console.WriteLine(err.ToString());
			}
			finally
			{
				con.Close();
			}

			Console.ReadLine();
		}

	}
}
