using System;
using System.Windows.Forms;
using Microsoft.Win32;

public class Form1 : System.Windows.Forms.Form
{
	/// <summary>
	/// Bentigte Designer-Variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public Form1()
	{
		//
		// Bentigt fr die Windows-Forms-Designer-Untersttzung.
		//
		InitializeComponent();

	}

	/// <summary>
	/// Verwendete Ressourcen bereiningen.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if (components != null) 
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		// 
		// Form1
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(292, 266);
		this.Name = "Form1";
		this.Text = "Form1";
		this.Load += new System.EventHandler(this.Form1_Load);
		this.Closed += new System.EventHandler(this.Form1_Closed);

	}
	#endregion

	/// <summary>
	/// Der Haupteinstiegspunkt der Anwendung.
	/// </summary>
	[STAThread]
	static void Main() 
	{
		Application.Run(new Form1());
	}

	private FormSettingStore formSettings;

	private void Form1_Load(object sender, System.EventArgs e)
	{
		formSettings = new FormSettingStore(@"Software\MyApp\", this.Name);
		formSettings.ApplySettings(this);
	}

	private void Form1_Closed(object sender, System.EventArgs e)
	{
		formSettings.SaveSettings(this);
	}
}

public class FormSettingStore
{
	private string regPath;
	private string formName;
	private RegistryKey key;

	public string RegistryPath
	{
		get 
		{ return regPath; }
	}
						 
	public string FormName
	{
		get 
		{ return formName; }
	}

	public FormSettingStore(string registryPath, string formName)
	{
		this.regPath = registryPath;
		this.formName = formName;

		// Schlssel erstellen, falls dieser noch nicht existiert.
		key = Registry.LocalMachine.CreateSubKey(registryPath + formName);
	}

	public void SaveSettings(System.Windows.Forms.Form form)
	{
		key.SetValue("Height", form.Height);
		key.SetValue("Width", form.Width);
		key.SetValue("Left", form.Left);
		key.SetValue("Top", form.Top);
	}

	public void ApplySettings(System.Windows.Forms.Form form)
	{
		// Falls die Formular-Einstellungen nicht verfgbar sind, die
		// aktuellen Formular-Einstellungen stattdessen verwenden.
		form.Height = (int)key.GetValue("Height", form.Height);
		form.Width = (int)key.GetValue("Width", form.Width);
		form.Left = (int)key.GetValue("Left", form.Left);
		form.Top = (int)key.GetValue("Top", form.Top);
	}
}