using System;
using System.IO;
using System.Drawing;
using System.Windows.Forms;

public class AutoCompleteComboBoxTest : System.Windows.Forms.Form
{
	/// <summary>
	/// Bentigte Designer-Variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public AutoCompleteComboBoxTest()
	{
		//
		// Bentigt fr die Windows-Forms-Designer-Untersttzung.
		//
		InitializeComponent();

		//
		// TODO: Konstruktor-Code nach der Ausfhrung von InitializeComponent hier einfgen.
		//
	}

	/// <summary>
	/// Verwendete Ressourcen bereinigen.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if (components != null) 
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		// 
		// AutoCompleteComboBoxTest
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
		this.ClientSize = new System.Drawing.Size(352, 106);
		this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
		this.Name = "AutoCompleteComboBoxTest";
		this.Text = "Auto-Vervollstndigen-ComboBox-Test";
		this.Load += new System.EventHandler(this.AutoCompleteComboBox_Load);

	}
	#endregion

	/// <summary>
	/// Der Haupteinstiegspunkt der Anwendung.
	/// </summary>
	[STAThread]
	static void Main() 
	{
		Application.Run(new AutoCompleteComboBoxTest());
	}




	private void AutoCompleteComboBox_Load(object sender, System.EventArgs e)
	{
		// Die Combo-Box dem Formular hinzufgen.
		AutoCompleteComboBox combo = new AutoCompleteComboBox();
		combo.Location = new Point(10,10);
		this.Controls.Add(combo);

		// Wortliste hinzufgen.
		FileStream fs = new FileStream("words.txt", FileMode.Open);
		using (StreamReader r = new StreamReader(fs))
		{
			while (r.Peek() > -1)
			{
				string word = r.ReadLine();
				combo.Items.Add(word);
			}
		}
	}
}

public class AutoCompleteComboBox : ComboBox
{
	// Sonderzeichentaste abfangen.
	// (denn in diesem Fall wird das Text-Ersetzen ausgelassen).
	private bool controlKey = false;

	// Bestimmen, ob eine bestimmte Taste gedrckt wurde.
	protected override void OnKeyPress(System.Windows.Forms.KeyPressEventArgs e)
	{
		base.OnKeyPress(e);
		
		if (e.KeyChar == (int)Keys.Escape)
		{
			// Textfeld lschen
			this.SelectedIndex = -1;
			this.Text = "";
			controlKey = true;
		}
		else if (Char.IsControl(e.KeyChar))
		{
			controlKey = true;
		}
		else
		{
			controlKey = false;
		}
	}

	// Textersetzung durchfhren.
	protected override void OnTextChanged(System.EventArgs e)
	{
		base.OnTextChanged(e);

		if (this.Text != "" && !controlKey)
		{
			// Den passenden Eintrag in der Liste suchen.
			string matchText = this.Text;
			int match = this.FindString(matchText);
			
			// Falls passender Eintrag gefunden wurde, diesen jetzt einfgen.
			if (match != -1)
			{
				this.SelectedIndex = match;
				
				// Nur die hinzugefgten Buchstaben markieren,
				// damit der Benutzer seine Eingabe fortsetzen kann.
				this.SelectionStart = matchText.Length;
				this.SelectionLength = this.Text.Length - this.SelectionStart;
			}
		}
	}
}