using System;
using System.Drawing.Printing;

public class ListPrinters
{
	/// <summary>
	/// The main entry point for the application.
	/// </summary>
	[STAThread]
	private static void Main(string[] args)
	{		
		foreach (string printerName in PrinterSettings.InstalledPrinters)
		{
			// Druckernamen anzeigen.
			Console.WriteLine("Drucker: {0}", printerName);

			// Druckereinstellungen abrufen.
			PrinterSettings printer = new PrinterSettings();
			printer.PrinterName = printerName;
			
			// berprfen, ob es sich um einen gltigen Drucker handelt.
			// (Dieser Schritt kann notwendig sein, wenn Sie einen Druckernamen
			// aus einem vom Benutzer bereitgestellten Wert, der Registrierung oder einer
			// Konfigurationsdatei lesen.)
			if (printer.IsValid)
			{
				// Die Liste gltiger Auflsungen darstellen.
				Console.WriteLine("Untersttzte Auflsungen:");
			
				foreach (PrinterResolution resolution in printer.PrinterResolutions)
				{
					Console.WriteLine("  {0}", resolution);
				} 
				Console.WriteLine();

				// Die Liste gltiger Papiergren darstellen.
				Console.WriteLine("Unterstzte Papiergren:");
            
				foreach (PaperSize size in printer.PaperSizes)
				{
					if (Enum.IsDefined(size.Kind.GetType(), size.Kind))
					{
						Console.WriteLine("  {0}", size);
					}
				}
				Console.WriteLine();
			}
		}
		Console.ReadLine();
	}
}