using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Printing;

public class MultiPagePrint : System.Windows.Forms.Form
{
	private System.Windows.Forms.Button cmdPrint;
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public MultiPagePrint()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if (components != null) 
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.cmdPrint = new System.Windows.Forms.Button();
		this.SuspendLayout();
		// 
		// cmdPrint
		// 
		this.cmdPrint.Location = new System.Drawing.Point(52, 56);
		this.cmdPrint.Name = "cmdPrint";
		this.cmdPrint.Size = new System.Drawing.Size(104, 32);
		this.cmdPrint.TabIndex = 1;
		this.cmdPrint.Text = "Drucken";
		this.cmdPrint.Click += new System.EventHandler(this.cmdPrint_Click);
		// 
		// MultiPagePrint
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(292, 266);
		this.Controls.Add(this.cmdPrint);
		this.Name = "MultiPagePrint";
		this.Text = "Form1";
		this.ResumeLayout(false);

	}
	#endregion

	/// <summary>
	/// The main entry point for the application.
	/// </summary>
	[STAThread]
	static void Main() 
	{
		Application.Run(new MultiPagePrint());
	}

	private void cmdPrint_Click(object sender, System.EventArgs e)
	{
		// Ein Dokument mit 100 Zeilen erzeugen.
		string[] printText = new string[100];
		for (int i=0; i < 100; i++)
		{
			printText[i] = i.ToString();
			printText[i] += ": The quick brown fox jumps over the lazy dog.";
		}

		PrintDocument doc = new TextDocument(printText);
		doc.PrintPage += new PrintPageEventHandler(this.Doc_PrintPage);

		// Dem Benutzer erlauben, den Drucker und Druckeinstellungen festzulegen.
		PrintDialog dlgSettings = new PrintDialog();
		dlgSettings.Document = doc;

		// Wenn der Benutzer auf OK klick, das Dokument drucken.
		if (dlgSettings.ShowDialog() == DialogResult.OK)
		{

			// Diese Methode wird beendet, bevor der Druckauftrag startet.
			// Das PrintPage-Ereignis wird asynchron ausgelst.
			doc.Print();
		}
	}

	private void Doc_PrintPage(object sender, PrintPageEventArgs e)
	{
		// Das Dokument abrufen, dass das Ereignis auslste.
		// Sie knnten das Dokument auch in einer Klassen-Member-Variablen speichern,
		// aber dieser Ansaz ermglicht es Ihnen, mit der gleichen
		// Ereignisbehandlungsroutine verschiedene Druckdokumente
		// gleichzeitig zu verarbeiten.
		TextDocument doc = (TextDocument)sender;
        
		// Font definieren und Zeilenhhe bestimmen.
		Font font = new Font("Arial", 10);
		float lineHeight = font.GetHeight(e.Graphics);
		
		// Variablen erstellen, die die aktuelle Seitenposition speichern.
		float x = e.MarginBounds.Left;
		float y = e.MarginBounds.Top;
		
		// Seitenzhler erhhen (um die Seite anzugeben, die als nchstes gedruckt wird).
		doc.PageNumber += 1;
		
		// Alle Informationen drucken, die auf der Seite Platz haben.
		// Diese Schleife endet, wenn die nchste Zeile ber die Seite 
		// hinaus drucken wrde oder keine Zeilen zum Drucken mehr brig sind.

		while ((y + lineHeight) < e.MarginBounds.Bottom &&
			doc.Offset <= doc.Text.GetUpperBound(0))
		{
			e.Graphics.DrawString(doc.Text[doc.Offset], font, 
				Brushes.Black, x, y);

			// Zur nchsten Datenzeile wechseln.
			doc.Offset += 1;
			
			// Eine Zeile auf der Seite nach unten vorrcken.
			y += lineHeight;
		}
        
		if (doc.Offset < doc.Text.GetUpperBound(0))
		{
			// Es gibt immer noch eine Seite.
			// Das Ereignis muss noch einmal ausgelst werden.
			e.HasMorePages = true;
		}
		else
		{
		// Druck ist abgeschlossen.
			doc.Offset = 0;
		}
	}
}

public class TextDocument : PrintDocument
{
	private string[] text;
	private int pageNumber;
	private int offset;

	public string[] Text
	{
		get {return text;}
		set {text = value;}
	}

	public int PageNumber
	{
		get {return pageNumber;}
		set {pageNumber = value;}
	}

	public int Offset
	{
		get {return offset;}
		set {offset = value;}
	}

	public TextDocument(string[] text)
	{
		this.Text = text;
	}
}