using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Printing;

public class PrintPreview : System.Windows.Forms.Form
{
	/// <summary>
	/// Required designer variable.
	/// </summary>
	private System.ComponentModel.Container components = null;

	public PrintPreview()
	{
		//
		// Required for Windows Form Designer support
		//
		InitializeComponent();

		//
		// TODO: Add any constructor code after InitializeComponent call
		//
	}

	/// <summary>
	/// Clean up any resources being used.
	/// </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if (components != null) 
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

	#region Windows Form Designer generated code
	/// <summary>
	/// Required method for Designer support - do not modify
	/// the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{
		this.cmdPreview = new System.Windows.Forms.Button();
		this.printPreviewControl = new System.Windows.Forms.PrintPreviewControl();
		this.lstZoom = new System.Windows.Forms.ListBox();
		this.label1 = new System.Windows.Forms.Label();
		this.SuspendLayout();
		// 
		// cmdPreview
		// 
		this.cmdPreview.Location = new System.Drawing.Point(348, 300);
		this.cmdPreview.Name = "cmdPreview";
		this.cmdPreview.Size = new System.Drawing.Size(104, 28);
		this.cmdPreview.TabIndex = 1;
		this.cmdPreview.Text = "Aktualisieren";
		this.cmdPreview.Click += new System.EventHandler(this.cmdPreview_Click);
		// 
		// printPreviewControl
		// 
		this.printPreviewControl.AutoZoom = false;
		this.printPreviewControl.Location = new System.Drawing.Point(12, 16);
		this.printPreviewControl.Name = "printPreviewControl";
		this.printPreviewControl.Size = new System.Drawing.Size(316, 312);
		this.printPreviewControl.TabIndex = 2;
		this.printPreviewControl.Zoom = 0.3;
		// 
		// lstZoom
		// 
		this.lstZoom.Location = new System.Drawing.Point(344, 44);
		this.lstZoom.Name = "lstZoom";
		this.lstZoom.Size = new System.Drawing.Size(104, 212);
		this.lstZoom.TabIndex = 3;
		// 
		// label1
		// 
		this.label1.Location = new System.Drawing.Point(344, 20);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(88, 20);
		this.label1.TabIndex = 4;
		this.label1.Text = "Zoom:";
		// 
		// PrintPreview
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
		this.ClientSize = new System.Drawing.Size(464, 342);
		this.Controls.Add(this.label1);
		this.Controls.Add(this.lstZoom);
		this.Controls.Add(this.printPreviewControl);
		this.Controls.Add(this.cmdPreview);
		this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
		this.Name = "PrintPreview";
		this.Text = "PrintPreview";
		this.Load += new System.EventHandler(this.PrintPreview_Load);
		this.ResumeLayout(false);

	}
	#endregion

	/// <summary>
	/// The main entry point for the application.
	/// </summary>
	[STAThread]
	static void Main() 
	{
		Application.Run(new PrintPreview());
	}

	
	private void Doc_PrintPage(object sender, PrintPageEventArgs e)
	{
		// Das Dokument abrufen, dass das Ereignis auslste.
		// Sie knnten das Dokument auch in einer Klassen-Member-Variablen speichern,
		// aber dieser Ansaz ermglicht es Ihnen, mit der gleichen
		// Ereignisbehandlungsroutine verschiedene Druckdokumente
		// gleichzeitig zu verarbeiten.
		TextDocument doc = (TextDocument)sender;
 
		// Font definieren und Zeilenhhe bestimmen.
		Font font = new Font("Arial", 10);
		float lineHeight = font.GetHeight(e.Graphics);
		
		// Variablen erstellen, die die aktuelle Seitenposition speichern.
		float x = e.MarginBounds.Left;
		float y = e.MarginBounds.Top;
		
		// Seitenzhler erhhen (um die Seite anzugeben, die als nchstes gedruckt wird).
		doc.PageNumber += 1;
		
		// Alle Informationen drucken, die auf der Seite Platz haben.
		// Diese Schleife endet, wenn die nchste Zeile ber die Seite 
		// hinaus drucken wrde oder keine Zeilen zum Drucken mehr brig sind.
		while ((y + lineHeight) < e.MarginBounds.Bottom &&
			doc.Offset <= doc.Text.GetUpperBound(0))
		{
			e.Graphics.DrawString(doc.Text[doc.Offset], font, 
				Brushes.Black, x, y);

			// Zur nchsten Datenzeile wechseln.
			doc.Offset += 1;
			
			// Eine Zeile auf der Seite nach unten vorrcken.
			y += lineHeight;
		}
        
		if (doc.Offset < doc.Text.GetUpperBound(0))
		{
			// Es gibt immer noch eine Seite.
			// Das Ereignis muss noch einmal ausgelst werden.
			e.HasMorePages = true;
		}
		else
		{
			// Druck ist abgeschlossen.
			doc.Offset = 0;
		}
	}

	private System.Windows.Forms.Button cmdPreview;
	private System.Windows.Forms.PrintPreviewControl printPreviewControl;
	private System.Windows.Forms.ListBox lstZoom;
	private System.Windows.Forms.Label label1;

	private PrintDocument doc;

	private void PrintPreview_Load(object sender, System.EventArgs e)
	{
		// Die zulssigen Zoom-Einstellungen setzen.
		for (int i=1; i <= 10; i++)
		{
			lstZoom.Items.Add((i * 10).ToString());
		}

		// Ein Dokument mit 100 Zeilen erstellen.
		string[] printText = new string[100];
		for (int i=0; i < 100; i++)
		{
			printText[i] = i.ToString();
			printText[i] += ": The quick brown fox jumps over the lazy dog.";
		}

		doc = new TextDocument(printText);
		doc.PrintPage += new PrintPageEventHandler(this.Doc_PrintPage);

		lstZoom.Text = "100";
		printPreviewControl.Zoom = 1;
		printPreviewControl.Document = doc;
		printPreviewControl.Rows = 2;
	}

	private void cmdPreview_Click(object sender, System.EventArgs e)
	{
		// Zoom setzen.
		printPreviewControl.Zoom = Single.Parse(lstZoom.Text) / 100;

		// Beide Seiten bereinander anzeigen.
		printPreviewControl.Document = doc;

		// PrintDocument neu binden, um die Vorschau zu aktualisieren.
		printPreviewControl.Rows = 2;
	}


}

public class TextDocument : PrintDocument
{
	private string[] text;
	private int pageNumber;
	private int offset;

	public string[] Text
	{
		get {return text;}
		set {text = value;}
	}

	public int PageNumber
	{
		get {return pageNumber;}
		set {pageNumber = value;}
	}

	public int Offset
	{
		get {return offset;}
		set {offset = value;}
	}

	public TextDocument(string[] text)
	{
		this.Text = text;
	}
}