using System;
using System.IO;

public class FileInformation
{
	private static void Main(string[] args)
	{
		if (args.Length == 0)
		{
			Console.WriteLine("Bitte geben Sie einen Dateinamen an.");
			return;
		}

		FileInfo file = new FileInfo(args[0]);

        // Dateiinformationen anzeigen.
        Console.WriteLine("berprfe Datei: " + file.Name);
        Console.WriteLine("Datei ist vorhanden: " + file.Exists.ToString());
        if (file.Exists)
		{
            Console.Write("Datei erstellt am: ");
            Console.WriteLine(file.CreationTime.ToString());
            Console.Write("Datei zuletzt aktualisiert am: ");
            Console.WriteLine(file.LastWriteTime.ToString());
            Console.Write("Letzter Zugriff auf Datei am: ");
            Console.WriteLine(file.LastAccessTime.ToString());
            Console.Write("Dateigre (Bytes): ");
            Console.WriteLine(file.Length.ToString());
            Console.Write("Dateiattribute: ");
            Console.WriteLine(file.Attributes.ToString());

                // Entfernen Sie die Kommentarzeichen vor den folgenden Zeilen,
                // um den gesamten Dateiinhalt anzeigen zu lassen:
			//StreamReader r = file.OpenText();
			//Console.WriteLine(r.ReadToEnd());
			//r.Close();
		}
		Console.WriteLine();

		// Verzeichnisinformationen anzeigen.
        DirectoryInfo dir = file.Directory;
        
        Console.WriteLine("berprfe Verzeichnis: " + dir.Name);
        Console.WriteLine("In Verzeichnis: " + dir.Parent.Name);
        Console.Write("Verzeichnis ist vorhanden: ");
        Console.WriteLine(dir.Exists.ToString());

		if (dir.Exists)
		{
			Console.Write("Verzeichnis erstellt am: ");
			Console.WriteLine(dir.CreationTime.ToString());
			Console.Write("Verzeichnis zuletzt aktualisiert am: ");
			Console.WriteLine(dir.LastWriteTime.ToString());
			Console.Write("Letzter Zugriff auf Verzeichnis am: ");
			Console.WriteLine(dir.LastAccessTime.ToString());
			Console.Write("Verzeichnisattribute: ");
			Console.WriteLine(dir.Attributes.ToString());

			Console.WriteLine("Verzeichnis enthlt: " + 
				dir.GetFiles().Length.ToString() + " Dateien");
		}

		Console.ReadLine();
	}
}