using System;
using System.IO;

public class CopyDir
{
	private static void Main(string[] args)
	{
		if (args.Length < 2)
		{
			Console.WriteLine("Verwendung:   CopyDir [Quellpfad] [Zielpfad]");
			return;
		}

		DirectoryInfo sourceDir = new DirectoryInfo(args[0]);
		DirectoryInfo destinationDir = new DirectoryInfo(args[1]);

		FileSystemUtil.CopyDirectory(sourceDir, destinationDir);
		
		Console.WriteLine("Kopiervorgang abgeschlossen.");
		Console.ReadLine();
	}
}

public class FileSystemUtil 
{

	public static void CopyDirectory(DirectoryInfo source,
		DirectoryInfo destination) 
	{

		if (!destination.Exists) 
		{
			destination.Create();
		}

		// Alle Dateien kopieren.
		FileInfo[] files = source.GetFiles();
		foreach (FileInfo file in files) 
		{

			file.CopyTo(Path.Combine(destination.FullName, file.Name));
		}

		// Unterverzeichnisse verarbeiten.
		DirectoryInfo[] dirs = source.GetDirectories();
		foreach (DirectoryInfo dir in dirs) 
		{

			// Zielverzeichnis abrufen.
			string destinationDir = Path.Combine(destination.FullName, dir.Name);

			// CopyDirectory() rekursiv aufrufen.
			CopyDirectory(dir, new DirectoryInfo(destinationDir));
		}
	}
}