using System;
using System.IO;

public class CalculateDirSize
{
	private static void Main(string[] args)
	{
		if (args.Length == 0)
		{
			Console.WriteLine("Bitte geben Sie einen Verzeichnispfad an.");
			return;
		}

		DirectoryInfo dir = new DirectoryInfo(args[0]);
		Console.WriteLine("Gesamtgre: " + FileSystemUtil.CalculateDirectorySize(dir, true).ToString() + " Bytes.");
		Console.ReadLine();
	}
}

public class FileSystemUtil 
{

	public static long CalculateDirectorySize(DirectoryInfo directory,
		bool includeSubdirectories) 
	{

		long totalSize = 0;

		// Alle enthaltenen Dateien untersuchen.
		FileInfo[] files = directory.GetFiles();
		foreach (FileInfo file in files) 
		{
			totalSize += file.Length;
		}

		// Alle enthaltenen Verzeichnisse untersuchen.
		if (includeSubdirectories) 
		{

			DirectoryInfo[] dirs = directory.GetDirectories();
			foreach (DirectoryInfo dir in dirs) 
			{
				totalSize += CalculateDirectorySize(dir, true);
			}
		}

		return totalSize;
	}
}
