using System;
using System.IO;
using System.Text;

public class TextFileTest
{
	private static void Main()
	{
		// Eine neue Datei erstellen.
		FileStream fs = new FileStream("test.txt", FileMode.Create);

		// Create a writer and specify the encoding.
		// The default (UTF-8) supports special Unicode characters,
		// but encodes all standard characters in the same way as
		// ASCII encoding.
		// Ein StreamWriter-Objekt erstellen und die Kodierung festlegen.
		// Die Standardkodierung (UTF-8 ) untersttzt spezielle Unicode-Zeichen.
		// Alle Standardzeichen werden jedoch genauso wie bei der ASCII-Kodierung kodiert.
		StreamWriter w = new StreamWriter(fs, Encoding.UTF8);

		// Einen decimal-, string- und char-Wert schreiben.
		w.WriteLine(124.23M);
		w.WriteLine("Teststring");
		w.WriteLine('!');

		// Sicherstellen, dass alle Daten aus dem internen Puffer geschrieben wurden.
		w.Flush();

		// Datei schlieen.
		w.Close();
		fs.Close();

		Console.WriteLine("Drcken Sie Enter, um die Informationen zu lesen.");
		Console.ReadLine();

		// Die Datei im schreibgeschtzten Modus ffnen.
		fs = new FileStream("test.txt", FileMode.Open);
		StreamReader r = new StreamReader(fs, Encoding.UTF8);

		// Die Daten lesen und in die entsprechenden Datentypen konvertieren.
		Console.WriteLine(Decimal.Parse(r.ReadLine()));
		Console.WriteLine(r.ReadLine());
		Console.WriteLine(Char.Parse(r.ReadLine()));
		
		r.Close();
		fs.Close();

		Console.ReadLine();
	}
}
