using System;
using System.IO;

public class BinaryFileTest
{
	private static void Main()
	{
		// Eine neue Datei und ein neues BinaryWriter-Objekt erstellen
		FileStream fs = new FileStream("test.txt", FileMode.Create);
		BinaryWriter w = new BinaryWriter(fs);

		// Einen decimal-, zwei string- und einen char-Wert schreiben.
		w.Write(124.23M);
		w.Write("Teststring");
		w.Write("Teststring 2");
		w.Write('!');

		// Sicherstellen, dass alle Daten aus dem internen Puffer geschrieben werden.
		w.Flush();

		// Datei schlieen.
		w.Close();
		fs.Close();

		Console.WriteLine("Drcken Sie Enter, um die Informationen zu lesen.");
		Console.ReadLine();

		// Die Datei im schreibgeschtzten Modus ffnen.
		fs = new FileStream("test.txt", FileMode.Open);

		// Die in der Datei gespeicherten Informationen anzeigen.
		StreamReader sr = new StreamReader(fs);
		Console.WriteLine(sr.ReadToEnd());
		Console.WriteLine();

		// Die Daten lesen und in die entsprechenden Datentypen konvertieren.
		fs.Position = 0;
		BinaryReader br = new BinaryReader(fs);
		Console.WriteLine(br.ReadDecimal());
		Console.WriteLine(br.ReadString());
		Console.WriteLine(br.ReadString());
		Console.WriteLine(br.ReadChar());
		
		fs.Close();

		Console.ReadLine();
	}
}