using System;
using System.IO;
using System.Security.Cryptography;

public class CompareFiles
{
	private	static void Main(string[] args)
	{
		if (args.Length != 2)
		{
			Console.WriteLine("Verwendung:  CompareFiles [Dateiname1] [Dateiname2]");
			return;
		}    

        Console.WriteLine("Vergleiche " + args[0] + " und " + args[1]);

        // Das Hash-Objekt erstellen.
        HashAlgorithm hashAlg = HashAlgorithm.Create();

        // Hash fr die erste Datei berechnen.
        FileStream fsA = new FileStream(args[0], FileMode.Open);
        byte[] hashBytesA = hashAlg.ComputeHash(fsA);
		fsA.Close();

        // Hash fr die zweite Datei berechnen.
		FileStream fsB = new FileStream(args[1], FileMode.Open);
		byte[] hashBytesB = hashAlg.ComputeHash(fsB);
		fsB.Close();

        // Hash-Codes vergleichen.
		if (BitConverter.ToString(hashBytesA) ==
			BitConverter.ToString(hashBytesB))
		{
			Console.WriteLine("Dateien stimmen berein.");
		}
		else
		{
			Console.WriteLine("Keine bereinstimmung.");
		}
        
		Console.ReadLine();

	}
}