using System;
using System.IO;
using System.IO.IsolatedStorage;

public class IsolatedStoreTest
{
	private static void Main()
	{
            
        // Den Speicher fr den aktullen Benutzer erstellen.
		IsolatedStorageFile store = IsolatedStorageFile.GetUserStoreForAssembly();

        // Einen Ordner im Stammverzeichnis des isolierten Speichers erstellen.
		store.CreateDirectory("MyFolder");
		
		// Eine Datei im isolierten Speicher erstellen.
		Stream fs = new IsolatedStorageFileStream("MyFile.txt", FileMode.Create, store);

        StreamWriter w = new StreamWriter(fs);

		// Sie knnen nun wie gewohnt in die Datei schreiben.
		w.WriteLine("Test");
		w.Flush();
		fs.Close();
		
		Console.WriteLine("Aktuelle Gre: " + store.CurrentSize.ToString());
		Console.WriteLine("Gltigkeitsbereich: " + store.Scope.ToString());

		Console.WriteLine("Enthaltene Dateien:");
		string [] files = store.GetFileNames("*.*");
		foreach (string file in files)
		{
			Console.WriteLine(file);
		}
    
		Console.ReadLine();
	}
}