using System;
using System.IO;
using System.Windows.Forms;

public class FileWatcherTest
{
	private static void Main()
	{
		// FileSystemWatcher konfigurieren.
		FileSystemWatcher watch = new FileSystemWatcher();
		watch.Path = Application.StartupPath;
		watch.Filter = "*.*";
		watch.IncludeSubdirectories = true;

		// Ereignis-Handler verknpfen.
		watch.Created += new FileSystemEventHandler(OnCreatedOrDeleted);        
		watch.Deleted += new FileSystemEventHandler(OnCreatedOrDeleted);
		watch.EnableRaisingEvents = true;

		Console.WriteLine("Drcken Sie Enter, um eine Datei zu erstellen.");
		Console.ReadLine();
		
		if (File.Exists("test.bin"))
		{
			File.Delete("test.bin");
		}

		FileStream fs = new FileStream("test.bin", FileMode.Create);
		fs.Close();

		Console.WriteLine("Drcken Sie Enter, um die Anwendung zu beenden.");
		Console.WriteLine();
		Console.ReadLine();
	}

	// Wird ausgelst, wenn in dem berwachten Verzeichnis eine neue Datei erstellt wird.
	private static void OnCreatedOrDeleted(object sender, FileSystemEventArgs e) 
	{
		// Benachrichtigungsinformationen anzeigen.
		Console.WriteLine("\tBENACHRICHTIGUNG: " + e.FullPath +
			"' wurde " + e.ChangeType.ToString());
		Console.WriteLine();
	}

}