using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.OleDb;

public class ConnectionExample {

    public static void Main() {

        // Mit SqlConnection Verbindung ffnen.
        SqlConnectionExample();
        Console.WriteLine(Environment.NewLine);

        //Mit OleDbConnection Verbindung ffnen.
        OleDbConnectionExample();

        // Auf Tastendruck warten.
        Console.ReadLine();
    }

    public static void SqlConnectionExample() {

        // Ein leeres SqlConnection-Objekt erstellen.
        using (SqlConnection con = new SqlConnection()) {

            // Die Verbindungszeichenfolge des SqlConnection-Objekts konfigurieren.
            con.ConnectionString = 
                "Data Source = localhost;"+ // lokale SQL Server-Instanz
                "Database = Northwind;" +   // die Beispieldatenbank Northwind
                "Integrated Security=SSPI"; // integrierte Windows-Sicherheit

            // Datenbankverbindung ffnen.
            con.Open();

            // Informationen ber die Verbindung anzeigen.
            if (con.State == ConnectionState.Open) {
                Console.WriteLine("SqlConnection-Informationen:");
                Console.WriteLine("  Verbindungsstatus = " + con.State);
                Console.WriteLine("  Verbindungszeichenfolge = " + 
                    con.ConnectionString);
                Console.WriteLine("  Datenbankquelle = " + con.DataSource);
                Console.WriteLine("  Datenbank = " + con.Database);
                Console.WriteLine("  Serverversion = " + con.ServerVersion);
                Console.WriteLine("  Workstation-ID = " + con.WorkstationId);
                Console.WriteLine("  Timeout = " + con.ConnectionTimeout);
                Console.WriteLine("  Paketgre = " + con.PacketSize);
            } else {
                Console.WriteLine("SqlConnection konnte nicht geffnet werden.");
                Console.WriteLine("  Verbindungsstatus = " + con.State);
            }
            // Am Ende des using-Blocks ruft Dispose() Close() auf.
        }
    }

    public static void OleDbConnectionExample() {

        // Ein leeres OleDbConnection-Objekt erstellen.
        using (OleDbConnection con = new OleDbConnection()) {

            // Die Verbindungszeichenfolge des OleDbConnection-Objekts konfigurieren.
            con.ConnectionString = 
                "Provider = SQLOLEDB;" +         // OLE DB-Provider fr SQL Server
                "Data Source = localhost;" +     // lokale SQL Server-Instanz
                "Initial Catalog = Northwind;" + // die Beispieldatenbank Northwind
                "Integrated Security=SSPI";      // integrierte Windows-Sicherheit

            // Datenbankverbindung ffnen.
            con.Open();

            // Informationen ber die Verbindung anzeigen.
            if (con.State == ConnectionState.Open) {
                Console.WriteLine("OleDbConnection-Informationen:");
                Console.WriteLine("  Verbindungsstatus = " + con.State);
                Console.WriteLine("  Verbindungszeichenfolge = " + 
                    con.ConnectionString);
                Console.WriteLine("  Datenbankquelle = " + con.DataSource);
                Console.WriteLine("  Datenbank = " + con.Database);
                Console.WriteLine("  Serverversion = " + con.ServerVersion);
                Console.WriteLine("  Timeout = " + con.ConnectionTimeout);
            } else {
                Console.WriteLine("OleDbConnection konnte nicht geffnet werden.");
                Console.WriteLine("  Verbindungsstatus = " + con.State);
            }
            // At the end of the using block Dispose() calls Close().
        }
    }
}
