using System;
using System.Data.SqlClient;

public class PoolingExample {
    
    public static void Main() {

        // Eine Verbindung aus dem Pool abrufen.
        using (SqlConnection con = new SqlConnection()) {

            // Die Verbindungszeichenfolge des SqlConnection-Objekts konfigurieren.
            con.ConnectionString = 
                "Data Source = localhost;" +    // lokale SQL Server-Instanz
                "Database = Northwind;" +       // die Beispieldatenbank Northwind
                "Integrated Security = SSPI;" + // integrierte Windows-Sicherheit
                "Min Pool Size = 5;" +          // Mindestgre des Pools konfigurieren
                "Max Pool Size = 15;" +         // Maximale Gre des Pools konfigurieren
                "Connection Reset = True;" +    // Verbindung bei jeder Verwendung zurcksetzen
                "Connection Lifetime = 600";    // Maximale Lebensdauer setzen

            // Datenbankverbindung ffnen.
            con.Open();

            // Auf Datenbank zugreifen...

	// Am Ende des using-Blocks ruft Dispose die Methode Close auf, die
	// die Verbindung wieder im Pool ablegt, sodass sie wiederverwendet werden kann.
        }

        // Eine Verbindung abrufen, die sich nicht im Pool befindet.
        using (SqlConnection con = new SqlConnection()) {

            // Die Verbindungszeichenfolge des SqlConnection-Objekts konfigurieren.
            con.ConnectionString = 
                "Data Source = localhost;" +    // lokale SQL Server-Instanz
                "Database = Northwind;" +       // die Beispieldatenbank Northwind
                "Integrated Security = SSPI;" + // integrierte Windows-Sicherheit
                "Pooling = False";              // keine Verbindung aus dem Pool verwenden

            // Datenbankverbindung ffnen.
            con.Open();

            // Auf die Datenbank zugreifen...

	// Am Ende des using-Blocks ruft Dispose die Methode Close auf, die
	// die Verbindung wieder im Pool ablegt, sodass sie wiederverwendet werden kann.
        }

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
