using System;
using System.Data;
using System.Data.SqlClient;

public class DataReaderExample {

    public static void Main() {

        // Ein neues SqlConnection-Objekte erstellen.
        using (SqlConnection con = new SqlConnection()) {

            // Die Verbindungszeichenfolge des SqlConnection-Objekts konfigurieren.
            con.ConnectionString = "Data Source = localhost;" + 
                "Database = Northwind; Integrated Security=SSPI";

            // Einen neuen Befehl erstellen und konfigurieren.
            SqlCommand com = con.CreateCommand();
            com.CommandType = CommandType.Text;
            com.CommandText = "SELECT BirthDate,FirstName,LastName FROM " +
                "Employees ORDER BY BirthDate;SELECT * FROM Employees";

	// Die Datenbankverbindung ffnen und die Beispielbefehle ber
	// die Verbindung ausfhren.
            con.Open();

            // Den Befehl ausfhren und ein SqlReader-Objekt abrufen.
            using (SqlDataReader reader = com.ExecuteReader()) {

	// Die ersten Ergebnisse verarbeiten und den Inhalt der
	// Ergebnisgruppe anzeigen.
                Console.WriteLine("Geburtstage der Angestellten (nach Alter).");

                while (reader.Read()) {

                    Console.WriteLine("{0,18:D} - {1} {2}", 
                        reader.GetDateTime(0),  // Typisierte Daten abrufen
                        reader["FirstName"],    // String-Index verwenden
                        reader[2]);             // Ordinalindex verwenden
                }

		// Die zweite Ergebnisgruppe verarbeiten und Details
		// ber die darin enthaltenen Spalten und Datentypen anzeigen.
                reader.NextResult();
                Console.WriteLine("Metadaten der Tabelle Employee.");
                for (int field = 0; field < reader.FieldCount; field++) {

                    Console.WriteLine("  Spaltenname:{0}  Type:{1}",
                        reader.GetName(field), 
                        reader.GetDataTypeName(field));
                }

            }
        }

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
