using System;
using System.Xml;
using System.Data;
using System.Data.SqlClient;

public class DisconnectedXmlQueryExample {

    public static void Main() {

		XmlDocument doc = new XmlDocument();

		// Ein neues SqlConnection-Objekt erstellen.
		using (SqlConnection con = new SqlConnection()) {

			// Die Verbindungszeichenfolge des SqlConnection-Objekts konfigurieren.
			con.ConnectionString = "Data Source = localhost;" + 
				"Database = Northwind; Integrated Security=SSPI";

			// Einen neuen Befehl erstellen und konfigurieren, der die Klausel
			// FOR XML AUTO enthlt.
			SqlCommand com = con.CreateCommand();
			com.CommandType = CommandType.Text;
			com.CommandText = 
				"SELECT CustomerID, CompanyName FROM Customers FOR XML AUTO";

			// Die Datenbankverbindung ffnen.
			con.Open();

			// Die XML-Daten in das XmlDocument-Objekt laden. Zunchst muss ein Stammelement
			// erstellt werden, in dem jedes Element des Ergebnisdatensatzes angeordnet werden kann.
			XmlReader reader = com.ExecuteXmlReader();
			doc.LoadXml("<results></results>");

			// Ein XmlNode-Objekt aus den nchsten XML-Element erstellen, das
			// vom Leser gelesen wird.
			XmlNode newNode = doc.ReadNode(reader);

			while (newNode != null) {

				doc.DocumentElement.AppendChild(newNode);
				newNode = doc.ReadNode(reader);
			}
		}

		// Das nicht mehr verbundene XmlDocument verarbeiten.
		Console.WriteLine(doc.OuterXml);

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
