using System;
using System.Xml;
using System.Data;
using System.Data.SqlClient;

public class XmlQueryExample {

    public static void Main() {

        // Ein neues SqlConnection-Objekt erstellen.
        using (SqlConnection con = new SqlConnection()) {

            // Die Verbindungszeichenfolge des SqlConnection-Objekts konfigurieren.
            con.ConnectionString = "Data Source = localhost;" + 
                "Database = Northwind; Integrated Security=SSPI";

	// Einen neuen Befehl erstellen und konfigurieren, der die Klausel
	// FOR XML AUTO enthlt.
            SqlCommand com = con.CreateCommand();
            com.CommandType = CommandType.Text;
            com.CommandText = "SELECT CustomerID, CompanyName" + 
                " FROM Customers FOR XML AUTO";

	// Ein XmlReader-Objekt deklarieren, sodass es in der finally-Klausel referenziert
	// und geschlossen werden kann.
            XmlReader reader = null;

            try {
                // Die Datenbankverbindung ffnen.
                con.Open();

	// Den Befehl ausfhren und ein XmlReader-Objekt abrufen, um
	// auf die Ergebnisse zuzugreifen.
                reader = com.ExecuteXmlReader();

                while (reader.Read()) {

                    Console.Write("Element: " + reader.Name);
                    if (reader.HasAttributes) {
                        for (int i = 0; i < reader.AttributeCount; i++) {

                            reader.MoveToAttribute(i);
                            Console.Write("  {0}: {1}",
                                reader.Name, reader.Value);
                        }

                        // Das XmlReader-Objekt auf den Elementknoten zurcksetzen.
                        reader.MoveToElement();  
                        Console.WriteLine();
                    }
                }
            } catch (Exception ex) {

                Console.WriteLine(ex.ToString());
            } finally {

                // Sicherstellen, dass der Leser geschlossen ist.
                if (reader != null) reader.Close();
            }
        }

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
