using System;
using System.Net;
using System.Net.Sockets;
using System.IO;
using SharedComponent;


public class TcpServerTest
{
	private static void Main()
	{
		// Erstellen eines neuen Listeners (Abhrer) an Anschluss 8000
		TcpListener listener = new TcpListener(IPAddress.Parse("127.0.0.1"), 
			8000);
        
		Console.WriteLine("Initialisiere Anschluss.");
		listener.Start();
        Console.WriteLine("Warte auf eingehende Verbindungsanforderungen...");
        
		try
		{
			// Auf eingehende Verbindungsanforderung warten 
			// und einen fr die Kommunikation initalisierten TcpClient zurckgeben. 
			TcpClient client = listener.AcceptTcpClient();
			Console.WriteLine("Connection accepted.");
            
			// Den Netzwerk-Stream abrufen.
			NetworkStream stream = client.GetStream();
			
			// Einen BinaryWriter erstellen, um in den Stream zu schreiben.
			BinaryWriter w = new BinaryWriter(stream);
            
			// Einen BinaryReader erstellen, um aus dem Stream zu lesen.
			BinaryReader r = new BinaryReader(stream);
            
			if (r.ReadString() == ClientMessages.RequestConnect)
			{
				w.Write(ServerMessages.AcknowledgeOK);
				Console.WriteLine("Verbindung beendet.");
                
				while (r.ReadString() != ClientMessages.Disconnect)
				{}
				
				Console.WriteLine();
				Console.WriteLine("Verbindungstrennungsanforderung empfangen.");
				w.Write(ServerMessages.Disconnect);
			}
			else
			{
				Console.WriteLine("Verbindung konnte nicht beendet werden.");
			}
			
			// Den Verbindungs-Socket schlieen.
			client.Close();
			Console.WriteLine("Connection closed.");
			
			// Den zugrundeliegenden Socket schlieen (das Abhren neuer Anforderungen stoppen).
			listener.Stop();
			Console.WriteLine("Listener gestoppt.");
		}
		catch (Exception err)
		{
			Console.WriteLine(err.ToString());
		}
    
		Console.ReadLine();
	}
}