using System;
using System.Net;
using System.Net.Sockets;
using System.IO;
using SharedComponent;


public class TcpClientTest
{
	private static void Main()
	{
		TcpClient client = new TcpClient();
		
		try
		{
			Console.WriteLine("Verbindungsversuch mit Server " +
				"ber Anschluss 8000.");
			client.Connect(IPAddress.Parse("127.0.0.1"), 8000);
			Console.WriteLine("Verbindung hergestellt.");
			
			// Den Netzwerk-Stream abrufen.
			NetworkStream stream = client.GetStream();
			
			// Einen BinaryWriter erstellen, um in den Stream zu schreiben.
			BinaryWriter w = new BinaryWriter(stream);
            
			// Einen BinaryReader erstellen, um aus dem Stream zu lesen.
			BinaryReader r = new BinaryReader(stream);
            
			// Einen Dialog starten.
			w.Write(ClientMessages.RequestConnect);
			
			if (r.ReadString() == ServerMessages.AcknowledgeOK)
			{
				Console.WriteLine("Verbunden.");
				Console.WriteLine("Enter drcken, um Verbindung zu trennen.");
				Console.ReadLine();
				Console.WriteLine("Trenne Verbindung...");
				w.Write(ClientMessages.Disconnect);
			}
			else
			{
				Console.WriteLine("Verbindung nicht beendet.");
			}

			// Den Verbindungs-Socket schlieen.
			client.Close();
			Console.WriteLine("Anschluss geschlossen.");
		}
		catch (Exception err)
		{
			Console.WriteLine(err.ToString());
		}
    
		Console.ReadLine();

	}
}