using System;
using System.Net;
using System.Net.Sockets;
using System.IO;
using SharedComponent;


public class TcpServerTest
{
	private static void Main()
	{
		// Erstellen eines neuen Listeners (Abhrer) an Anschluss 8000.
		TcpListener listener = new TcpListener(IPAddress.Parse("127.0.0.1"),
			8000);
        
		Console.WriteLine("Initialisiere Anschluss.");
		listener.Start();
        Console.WriteLine("Warte auf eingehende Verbindungsanforderungen...");
        
		try
		{
			// Auf eingehende Verbindungsanforderung warten 
			// und einen fr die Kommunikation initalisierten Socket zurckgeben. 
			Socket socket = listener.AcceptSocket();

			Console.WriteLine("Verbindung akzeptiert.");
            
			// Den Netzwerk-Stream erstellen.
			NetworkStream stream = new NetworkStream(socket);
			
			// Einen BinaryWriter erstellen, um in den Stream zu schreiben.
			BinaryWriter w = new BinaryWriter(stream);
            
			// Einen BinaryReader erstellen, um aus dem Stream zu lesen.
			BinaryReader r = new BinaryReader(stream);
            
			if (r.ReadString() == ClientMessages.RequestConnect)
			{
				w.Write(ServerMessages.AcknowledgeOK);
				Console.WriteLine("Verbindung beendet.");
                
				// Die Client-IP abrufen.
				Console.Write("Die IP-Adresse des Clients lautet: ");
				Console.WriteLine(((IPEndPoint)socket.RemoteEndPoint).Address.ToString());
				Console.Write("Der Client benutzt den lokalen Anschluss: ");
				Console.WriteLine(((IPEndPoint)socket.RemoteEndPoint).Port.ToString());

				while (r.ReadString() != ClientMessages.Disconnect)
				{}
				
				Console.WriteLine();
				Console.WriteLine("Verbindungstrennungsanforderung empfangen.");
				w.Write(ServerMessages.Disconnect);
			}
			else
			{
				Console.WriteLine("Verbindung konnte nicht beendet werden.");
			}
			
			// Den Verbindungs-Socket schlieen.
			socket.Close();
			Console.WriteLine("Verbindung geschlossen.");
			
			// Den zu Grunde liegenden Socket schlieen (das Warten auf neue Anforderungen beenden).
			listener.Stop();
			Console.WriteLine("Listener gestoppt.");
		}
		catch (Exception err)
		{
			Console.WriteLine(err.ToString());
		}
    
		Console.ReadLine();
	}
}

public class CustomTcpClient : TcpClient
{
	public Socket Socket
	{
		get
		{
			return this.Client;
		}
	}
}