using System;
using System.Net;
using System.Net.Sockets;
using System.IO;
using SharedComponent;

public class TcpServerTest
{
	private static void Main()
	{
		// Erstellen eines neuen Listeners (Abhrer) an Anschluss 8000.
		CustomTcpListener listener = new CustomTcpListener(IPAddress.Parse(
			"127.0.0.1"), 8000);

		listener.Socket.SetSocketOption(SocketOptionLevel.Socket,
			SocketOptionName.ReceiveTimeout, 1000);
        
		Console.WriteLine("Initialisiere Anschluss.");
		listener.Start();
        Console.WriteLine("Warte auf eingehende Verbindungsanforderungen...");
        
		try
		{
			// Auf eingehende Verbindungsanforderung warten 
			// und einen fr die Kommunikation initalisierten Socket zurckgeben. 
			Socket socket = listener.AcceptSocket();

			Console.WriteLine("Connection accepted.");
            
			// Den Netzwerk-Stream abrufen.
			NetworkStream stream = new NetworkStream(socket);
			
			// Einen BinaryWriter erstellen, um in den Stream zu schreiben.
			BinaryWriter w = new BinaryWriter(stream);
            
			// Einen BinaryReader erstellen, um aus dem Stream zu lesen.
			BinaryReader r = new BinaryReader(stream);
            
			if (r.ReadString() == ClientMessages.RequestConnect)
			{
				w.Write(ServerMessages.AcknowledgeOK);
				Console.WriteLine("Verbindung beendet.");
                
				// Client-IP abrufen.
				Console.Write("Die IP-Adresse des Clients lautet: ");
				Console.WriteLine(((IPEndPoint)socket.RemoteEndPoint).Address.ToString());
				Console.Write("Der Client verwendet den lokalen Anschluss: ");
				Console.WriteLine(((IPEndPoint)socket.RemoteEndPoint).Port.ToString());

				while (r.ReadString() != ClientMessages.Disconnect)
				{}
				
				Console.WriteLine();
				Console.WriteLine("Verbindungstrennungsanforderung empfangen.");
				w.Write(ServerMessages.Disconnect);
			}
			else
			{
				Console.WriteLine("Verbindung konnte nicht beendet werden.");
			}
			
			// Close the connection socket.
			socket.Close();
			Console.WriteLine("Verbindung geschlossen.");
			
			// Den zu Grunde liegenden Socket schlieen (das Warten auf neue Anforderungen beenden.
			listener.Stop();
			Console.WriteLine("Listener gestoppt.");
		}
		catch (Exception err)
		{
			Console.WriteLine(err.ToString());
		}
    
		Console.ReadLine();
	}
}

public class CustomTcpListener : TcpListener
{
	public Socket Socket
	{
		get
		{
			return base.Server;
		}
	}

	public CustomTcpListener(IPAddress ip, int port) : base(ip, port)
	{}
}