using System;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Threading;
using SharedComponent;

public class TcpServerTest
{
	private static void Main()
	{
		// Erstellen eines neuen Listeners (Abhrer) an Anschluss 8000.
		TcpListener listener = new TcpListener(IPAddress.Parse("127.0.0.1"), 
			8000); 
        
		Console.WriteLine("Server: Initialisiere Anschluss.");
		listener.Start();
        Console.WriteLine("Server: Warte auf eingehende Verbindungsanforderungen...");
        
		int clientNum = 0;
		while (true)
		{
			try 
			{
				// Auf eingehende Verbindungsanforderung warten 
				// und einen fr die Kommunikation initalisierten TcpClient zurckgeben. 

				TcpClient client = listener.AcceptTcpClient();
				Console.WriteLine("Server: Verbindung akzeptiert.");

				// Ein neues Objekt erstellen, um diese Verbindung zu bearbeiten.
				clientNum++;
				ClientHandler handler = new ClientHandler(client, "Client " +
					clientNum.ToString());

				// Dieses Objekt in einem anderen Thread ausfhren.
				Thread handlerThread = 
					new Thread(new ThreadStart(handler.Start));
				handlerThread.IsBackground = true;
				handlerThread.Start();

				// (Sie knnten Handler und HandlerThread auch zu einer Auflistung hinzufgen,
				// um die Client-Sitzungen zu berwachen.)
			}
			catch (Exception err) 
			{
				Console.WriteLine(err.ToString());
			}
		}
	}
}

public class ClientHandler 
{

	private TcpClient client;
	private string ID;

	public ClientHandler(TcpClient client, string ID) 
	{

		this.client = client;
		this.ID = ID;
	}

	public void Start() 
	{

		// Den Netzwerk-Stream abrufen.
		NetworkStream stream = client.GetStream();

		// Einen BinaryWriter erstellen, um in den Stream zu schreiben.
		BinaryWriter w = new BinaryWriter(stream);

		// Einen BinaryReader erstellen, um aus dem Stream zu lesen.
		BinaryReader r = new BinaryReader(stream);

		if (r.ReadString() == ClientMessages.RequestConnect) 
		{

			w.Write(ServerMessages.AcknowledgeOK);
			Console.WriteLine(ID + ": Verbindung beendet.");
			while (r.ReadString() != ClientMessages.Disconnect) {}

			Console.WriteLine(ID + ": Verbindungstrennungsanforderung empfangen.");
			w.Write(ServerMessages.Disconnect);
		}
		else 
		{
			Console.WriteLine(ID + ": Verbindung konnte nicht beendet werden.");
		}

		// Den Verbindungs-Socket schlieen.
		client.Close();
		Console.WriteLine(ID + ": Verbindung geschlossen.");

		Console.ReadLine();
	}
}
