using System;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Threading;

public class UdpTest 
{
	private static int localPort;

	private static void Main() 
	{

		// Endpunkt definieren, von dem die Nachrichten gesendet werden.
		Console.Write("Verbinden mit IP: ");
		string IP = Console.ReadLine();
		Console.Write("Verbinden mit Anschluss: ");
		int port = Int32.Parse(Console.ReadLine());
		

		IPEndPoint remoteEndPoint = new IPEndPoint(IPAddress.Parse(IP), 
			port);

		// Lokalen Endpunkt definieren (wo Nachrichten empfangen werden).
		Console.Write("Lokaler Anschluss zum Abhren: ");
		localPort = Int32.Parse(Console.ReadLine());
		
		Console.WriteLine();

		// Einen neuen Thread fr den Empfang eingehender Nachrichten erstellen.
		Thread receiveThread = new Thread(
			new ThreadStart(ReceiveData));
		receiveThread.IsBackground = true;
		receiveThread.Start();

		UdpClient client = new UdpClient();

		try 
		{
			string text;
			do 
			{
				text = Console.ReadLine();

				// Den Text zum Remote-Client senden.
				if (text != "") 
				{

					// Daten mit der UTF8-Kodierung in das Binrformat kodieren.
					byte[] data = Encoding.UTF8.GetBytes(text);

					// Den Text zum Remote-Client senden.
					client.Send(data, data.Length, remoteEndPoint);
				}
			} while (text != "");
		}
		catch (Exception err)
		{
			Console.WriteLine(err.ToString());
		}

		Console.ReadLine();
	}

	private static void ReceiveData() 
	{

		UdpClient client = new UdpClient(localPort);
		while (true) 
		{

			try 
			{
				// Bytes empfangen.
				IPEndPoint anyIP = new IPEndPoint(IPAddress.Any, 0);
				byte[] data = client.Receive(ref anyIP);

				// Bytes mit der UTF8-Kodierung in das Textformat kodieren.
				string text = Encoding.UTF8.GetString(data);

				// Den abgerufenen Text anzeigen.
				Console.WriteLine(">> " + text);
			}
			catch (Exception err) 
			{
				Console.WriteLine(err.ToString());
			}
		}
	}
}