public class AssemblyEvidenceExample {

    public static void Main() {
            	
        // Neue Site- und Zone-Beweisobjekte erstellen.
        System.Security.Policy.Site siteEvidence = 
            new System.Security.Policy.Site("www.microsoft.com");
        System.Security.Policy.Zone zoneEvidence = 
            new System.Security.Policy.Zone(System.Security.SecurityZone.Trusted);

        // Eine neue Evidence-Auflistung erstellen.
        System.Security.Policy.Evidence evidence = 
            new System.Security.Policy.Evidence();

        // Die Site- und Zone-Beweisobjekte mit der AddHost-Methode
        // zur Evidence-Auflistung hinzufgen.
        evidence.AddHost(siteEvidence);
        evidence.AddHost(zoneEvidence);

        // Die Assembly mit dem Namen "SomeAssembly" laden und die
        // neuen Site- und Zone-Beweisobjekte zuweisen. Dies berschreibt
        // die Site- und Zone-Beweisobjekte, die vom Assembly-Lader
        // zugewiesen wurden.
        System.Reflection.Assembly assembly = 
            System.Reflection.Assembly.Load("SomeAssembly", evidence);
            
        // Den Host-Beweis der Assembly anzeigen.
        System.Collections.IEnumerator x = assembly.Evidence.GetHostEnumerator();		
        System.Console.WriteLine("HOST-Beweis-Auflistung:");
        while(x.MoveNext()) {
            System.Console.WriteLine(x.Current.ToString());
        }

        // Auf Tastendruck warten.
        System.Console.ReadLine();
    }
}
