using System;
using System.Security.Principal;

public class WindowsGroupExample {

    public static void Main (string[] args) {
    
        // Ein WindowsIdentity-Objekt abrufen, das den gegenwrtig
        // angemeldeten Windows-Benutzer reprsentiert.
        WindowsIdentity identity = WindowsIdentity.GetCurrent();
        
        // Ein WindowsPrincipal-Objekt erstellen, das die Sicherheitsmerkmale
        // des angegebenen WindowsIdentity-Objekts reprsentiert. Das hier
        // angegebene WindowsIdentity-Objekt reprsentiert die Windows-
        // Benutzergruppe, der der aktuelle Benutzer zugehrt.
        WindowsPrincipal principal = new WindowsPrincipal(identity);
        
        // Die als Befehlszeilenargumente angegegbenen Gruppennamen sequenziell
        // verarbeiten und berprfen, ob der aktuelle Benutzer ein Mitglied der
        // jeweiligen Gruppe ist.
        foreach (string role in args) {
        
            Console.WriteLine("Ist {0} ein Mitglied von {1}? = {2}", 
                identity.Name, role, principal.IsInRole(role));
        }

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
