using System;
using System.IO;
using System.Security.Cryptography;

public class HashStreamExample {

    public static void Main(string[] args) {

        // Den HashAlgorithmus erstellen, der mit dem ersten
        // Befehlszeilenargument angegeben wird.
        using (HashAlgorithm hashAlg = HashAlgorithm.Create(args[0])) {

            // Einen FileStream zu der Datei ffnen, die mit dem zweiten
            // Befehlszeilenargument angegeben wird.
            using (Stream file = new FileStream(args[1], FileMode.Open)) {
    
                // Den Hashcode fr den Dateiinhalt generieren.
                byte[] hash = hashAlg.ComputeHash(file);
    
                // Den Hashcode der Datei im Konsolenfenster anzeigen.
                Console.WriteLine(BitConverter.ToString(hash));
            }
        }

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
