using System;
using System.Text;
using System.Security.Cryptography;

public class KeyedHashMessageExample {
    
    public static void Main(string[] args) {

        // Ein Byte-Array aus der Schlsselzeichenfolge erstellen, die mit dem 
        // zweiten Befehlszeilenargument angegeben wird.
        byte[] key = Encoding.Unicode.GetBytes(args[1]);

        // Ein HMACSHA1-Objekt erstellen, das den verschlsselten Hashcode fr 
        // die Nachricht generiert. Das Byte-Array, das den Schlssel reprsentiert, an den 
        // Konstruktor bergeben.
        using (HMACSHA1 hashAlg = new HMACSHA1(key)) {

            // Die Nachrichtenzeichenfolge, die mit dem ersten Befehlszeilenargument angegeben wird,
            // in ein Byte-Array konvertieren.
            byte[] msgData = Encoding.Unicode.GetBytes(args[0]);
    
            // Den verschlsselten Hashcode fr die Nachricht generieren.
            byte[] hash = hashAlg.ComputeHash(msgData);
    
            // Den verschlsselten Hashcode der Nachricht im Konsolenfenster anzeigen.
            Console.WriteLine(BitConverter.ToString(hash));
        }

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
