using System;
using System.IO;
using System.Text;
using System.Security.Cryptography;

public class KeyedHashStreamExample {

    public static void Main(string[] args) {

        // Ein Byte-Array aus der Schlsselzeichenfolge erstellen, die mit dem 
        // zweiten Befehlszeilenargument angegeben wird.
        byte[] key = Encoding.Unicode.GetBytes(args[1]);
        
        // Ein HMACSHA1-Objekt erstellen, das den verschlsselten Hashcode fr 
        // die Eingabedatei generiert. Das Byte-Array, das den Schlssel reprsentiert, an den 
        // Konstruktor bergeben.
        using (HMACSHA1 hashAlg = new HMACSHA1(key)) {

            // Ein FileStream ffnen, um die Eingabedatei zu lesen. Der Dateiname wird 
            // mit dem ersten Befehlszeilenargument angegeben.
            using (Stream file = new FileStream(args[0], FileMode.Open)) {
    
                // Den verschlsselten Hashcode fr den Dateiinhalt generieren.
                byte[] hash = hashAlg.ComputeHash(file);
    
                // Den verschlsselten Hashcode im Konsolenfenster anzeigen.
                Console.WriteLine(BitConverter.ToString(hash));
            }
        }

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
