using System;
using System.Security.Cryptography;

public class DerivedKeyExample {

    public static void Main(string[] args) {
        
        // Einen kryptographischen Zufallszahlengenerator verwenden, um 
        // das Salz zu erstellen, das vom Ableitungsalgorithmus verwendet wird.
        byte[] salt = new byte[8];
        RandomNumberGenerator.Create().GetBytes(salt);

        // Ein PasswordDeriveBytes-Objekt erstellen um 
        // den Schlssel aus dem Kennwort zu generieren. Stellen Sie das Quellkennwort zur Verfgung, das
        // mit dem zweiten Befehlszeilenargument angegeben wird, sowie das Salz.
        PasswordDeriveBytes pdb = 
            new PasswordDeriveBytes(args[1], salt);

        // Legen Sie den Hash-Algorithmus fest, der zur Erstellung des Schlssels verwendet wird. 
        // Der Algorithmusname wird mit dem ersten Befehlszeilenargument angegeben.
        // Der verwendete Standardalgorithmus ist SHA-1.
        pdb.HashName = args[0];

        // Die Schleifendurchlufe auf 200 setzen. Diese Zahl gibt Aufschluss darber
        // wie oft der Hash-Algorithmus auf das Kennwort angewendet wird, um 
        // den Schlssel zu generieren. Der Standard ist 100.
        pdb.IterationCount = 200;
        
        // Einen 8-Byte-Schlssel (64 Bit) aus dem Kennwort generieren.
        // Die Gre des Schlssels wird durch die Lnge
        // des Hashcodes begrenzt - 160 Bits fr SHA-1.
        byte[] key = pdb.GetBytes(8);
        
        // Den Schlssel und das Salz im Konsolenfenster anzeigen.
        Console.WriteLine("Schlssel = {0}", BitConverter.ToString(key));
        Console.WriteLine("Salz = {0}", BitConverter.ToString(salt));

        // Auf Tastendruck warten.
        Console.ReadLine();
    }
}
