using System;
using System.Text;
using System.Runtime.InteropServices;

public class GetWindows
{
	// Die Signatur fr die Rckrufmethode.
	public delegate bool CallBack(int hwnd, int lParam);

	// Die nicht verwaltete Funktion, die den Rckruf auslsen wird,
	// wenn sie die geffneten Fenster auflistet.
	[DllImport("user32.dll")]
	public static extern int EnumWindows(CallBack callback, int param); 

	[DllImport("user32.dll")]
	public static extern int GetWindowText(int hWnd, StringBuilder lpString, int nMaxCount);

	private static void Main()
	{
		CallBack callBack = new CallBack(DisplayWindowInfo);

		// Anfordern, dass das Betriebssystem alle Fenster auflistet und Ihren
		// Rckruf mit dem Handle jedes Fensters auslst.
		EnumWindows(callBack, 0);

		Console.ReadLine();
	}

	// Die Methode, die den Rckruf empfngt. Der zweite Parameter wird nicht
	// verwendet, ist aber erforderlich, um der Signatur des Rckrufs gerecht zu werden.
	public static bool DisplayWindowInfo(int hWnd, int lParam) 
	{ 
		int chars = 100;
		StringBuilder buf = new StringBuilder(chars);
		if (GetWindowText(hWnd, buf, chars) != 0)
		{
			Console.WriteLine(buf);
		}
		return true;
	}
}