using System;

[Serializable]
public sealed class MailReceivedEventArgs : EventArgs {

    // Private schreibgeschtzte Member, die den Ereignisstatus
    // speichern, der an alle Event-Handler bermittelt werden soll.
    // Die Klasse MailReceivedEventArgs gibt an, wer die empfangene
    // Nachricht versendet hat und worum es geht.
    private readonly string from;
    private readonly string subject;

    // Konstruktor, initialisiert den Ereignisstatus.
    public MailReceivedEventArgs(string from, string subject) {

        this.from = from;
        this.subject = subject;
    }

    // Schreibgeschtzte Eigenschaften, die den Zugriff auf den
    // Ereignisstatus ermglichen.
    public string From { get { return from; } }
    public string Subject { get { return subject; } }



    // Benutzen Sie die Main-Methoden, um die Klasse MailReceivedEventArgs zu testen.
    public static void Main() {

        MailReceivedEventArgs args = new MailReceivedEventArgs("Danielle", "Ihre Buchung");

        Console.WriteLine("Von: {0}, Betreff: {1}", args.From, args.Subject);
        Console.ReadLine();
    }
}
