using System;

public class AccessEnvironmentExample {

    public static void Main() {

        // Befehlszeile.
        Console.WriteLine("Befehlszeile: " + Environment.CommandLine);

        // Betriebssystem- und CLR-Versionsinformationen.
        Console.WriteLine("Betriebssystem-PlatformID : " + 
            Environment.OSVersion.Platform);
        Console.WriteLine("Betriebssystem-Hauptversion: " + 
            Environment.OSVersion.Version.Major);
        Console.WriteLine("Betriebssystem-Nebenversion : " + 
            Environment.OSVersion.Version.Minor);
        Console.WriteLine("CLR-Version: " + Environment.Version);

        // Benutzer-, Computer- und Domnennameninformationen.
        Console.WriteLine("Benutzername: " + Environment.UserName);
        Console.WriteLine("Domnenname: " + Environment.UserDomainName);
        Console.WriteLine("Computername : " + Environment.MachineName);

        // Andere Umgebungsinformationen.
        Console.WriteLine("Interaktiv? : " 
            + Environment.UserInteractive);
        Console.WriteLine("Wird heruntergefahren? : " 
            + Environment.HasShutdownStarted);
        Console.WriteLine("Millisekunden seit Start: " 
            + Environment.TickCount);

        // Die Namen aller logischen Laufwerke anzeigen.
        foreach (string s in Environment.GetLogicalDrives()) {
            Console.WriteLine("Logisches Laufwerk: " + s);
        }

        // Standardordnerinformationen.
        Console.WriteLine("Aktueller Ordner: " 
            + Environment.CurrentDirectory);
        Console.WriteLine("Systemordner: " 
            + Environment.SystemDirectory);

        // Alle speziellen Ordner auflisten und anzeigen.
        foreach (Environment.SpecialFolder s in 
            Enum.GetValues(typeof(Environment.SpecialFolder))) {

            Console.WriteLine("{0} Ordner: {1}", 
                s, Environment.GetFolderPath(s));
        }

        // Auf Tastendruck warten.
        Console.WriteLine("Main-Methode beendet. Drcken Sie Enter.");
        Console.ReadLine();
    }
}
