using System;
using System.Diagnostics;

public class EventLogExample {

    public static void Main () {

        // Diese Anwendung als Ereignisquelle fr das Anwendungsprotokoll
        // des lokalen Computers registrieren, sofern noch nicht vorhanden.
        // Der Versuch, auf dem angegebenen Computer eine Ereignisquelle
        // zu registrieren, die bereits vorhanden ist, lst die Ausnahme
        // System.ArgumentException aus.
        if (!EventLog.SourceExists("EventLogExample")) {

            EventLog.CreateEventSource("EventLogExample","Application");
        }

        // Ein Ereignis in das Ereignisprotokoll schreiben.
        EventLog.WriteEntry(
            "EventLogExample",             // Registrierte Ereignisquelle
            "Ein einfaches Testereignis.", // Ereigniseintrag
            EventLogEntryType.Information, // Ereignistyp
            1,                             // Anwendungsspezifische ID
            0,                             // Anwendungsspezifische Kategorie
            new byte[] {10, 55, 200}       // Ereignisdatum
        );

        // Auf Tastendruck warten.
        Console.WriteLine("Main-Methode beendet. Drcken Sie Enter.");
        Console.ReadLine();
    }
}
