using System;
using IWshRuntimeLibrary;

public class ShortcutExample {

    public static void Main() {

        // Die Notepad-Verknpfung auf dem Desktop erstellen.
        CreateShortcut("Desktop");

        // Die Notepad-Verknpfung im Startmen des aktuellen Benutzers erstellen.
        CreateShortcut("StartMenu");

        // Auf Tastendruck warten.
        Console.WriteLine("Main-Methode beendet. Drcken Sie Enter.");
        Console.ReadLine();
    }

    public static void CreateShortcut(string destination) {

        // Eine WshShell-Instanz erstellen, ber die auf die Funktionalitt der
        // Windows-Shell zugegriffen werden kann.
        WshShell wshShell = new WshShell();

        // Einen vollstndig angegebenen Namen generieren, der die Datei
        // Notepad.lnk im angegebenen Zielordner anordnet. Sie knnten die
        // Methode System.Environment.GetFolderPath verwenden, um einen Pfad
        // abzurufen, doch die Methode WshShell.SpecialFolders ermglicht den
        // Zugriff auf eine grere Zahl von Ordnern. Sie mssen eine temporre
        // Objektreferenz erstellen, die auf die Zielzeichenfolge verweist, um
        // die Anforderungen der Methode Item zu erfllen.
        object destFolder = (object)destination;
        string fileName = 
            (string)wshShell.SpecialFolders.Item(ref destFolder) 
            + @"\Notepad.lnk";

        // Das Verknpfungsobjekt erstellen. Im Zielordner geschieht solange
        // nichts, bis die Verknpfung gespeichert wird.
        IWshShortcut shortcut = 
            (IWshShortcut)wshShell.CreateShortcut(fileName);

        // Den vollstndig angegebenen Pfad und Namen der ausfhrbaren Datei konfigurieren.
        // Dies ist mit der Klasse Environment nicht schwierig.
        shortcut.TargetPath = 
            Environment.GetFolderPath(Environment.SpecialFolder.System) 
            + @"\notepad.exe";

        // Das Arbeitsverzeichnis auf den persnlichen (Personal) Ordner (Eigene Dateien) setzen.
        shortcut.WorkingDirectory =
            Environment.GetFolderPath(Environment.SpecialFolder.Personal);

        // Eine Beschreibung fr die Verknpfung generieren.
        shortcut.Description = "Notepad-Text-Editor";

        // Der Verknpfung einen Hotkey zuweisen.
        shortcut.Hotkey = "CTRL+ALT+N";

        // Notepad so konfigurieren, dass das Programm immer maximiert gestartet wird.
        shortcut.WindowStyle = 3;

        // Die Verknpfung so konfigurieren, dass sie das erste Symbol in notepad.exe anzeigt.
        shortcut.IconLocation = "notepad.exe, 0"; 

        // Die konfigurierte Verknpfungsdatei speichern.
        shortcut.Save();
    }
}
